<?php

class OLEControlWrapper {

	private   $__progID = '';
	protected $_deviceControl = NULL;

	function __construct($progID) {
		if (empty($progID)) throw new Exception("You have to specify PROGID when invoke __construct method of oleControlWrapper class.");
		$this->__progID = $progID;
	}

	protected function get_progID() {
		return $this->__progID;
	}

	protected function &get_DeviceControl() {
		if (!isset($this->_deviceControl) ) {
			try {
				$this->_deviceControl = new COM($this->__progID);
			} catch (com_exception $e) {
				if ($e->getCode() == -2147221020) {
					throw new Exception("Необходимый для работы COM-объект [{$this->__progID}] не зарегистрирован в системе. Переустановите его и повторите операцию.");
				} else {
					throw new Exception(iconv('windows-1251', 'utf-8', $e->getMessage()) . '. Code: 0x' . dechex($e->getCode()) . '; File: ' . $e->getFile() . ' at line ' . $e->getLine());
				}
			}

			if ($this->_deviceControl) {
				if (!$this->_initObject())
					throw new Exception('Error. Cannot init device ' . $this->__progID);
			} else {
				throw new Exception('Error. OLE-Object not created ' . $this->__progID);
			}
		}

		return $this->_deviceControl;
	}

	protected function _initObject() {
		return true;
	}

	protected function _OLEGetProperty($name) {
		try{
			$control = $this->get_DeviceControl();
			return $control->$name;
		} catch (com_exception $e)  {
			throw new Exception(iconv('windows-1251', 'utf-8', $e->getMessage()) . '. Code: 0x' . dechex($e->getCode()) . '; File: ' . $e->getFile() . ' at line ' . $e->getLine());
		}

	}

	protected function _OLESetProperty($name, $value) {
		try {
			$control = $this->get_DeviceControl();
			$control->$name = $value;
		} catch (com_exception $e)  {
			throw new Exception(iconv('windows-1251', 'utf-8', $e->getMessage()) . '. Code: 0x' . dechex($e->getCode()) . '; File: ' . $e->getFile() . ' at line ' . $e->getLine());
		}
		return true;
	}

	protected function _OLEInvokeMethod($name, $arguments) {
		try {
			$control = $this->get_DeviceControl();
			if (empty($arguments)) {
				$result = call_user_func(array($control, $name));
			} else {
				$result = call_user_func_array(array($control, $name), $arguments);
			}
			if ($result === FALSE) throw new Exception(iconv('windows-1251', 'utf-8', 'Method [' . $name . '] not supported'));
			return $result;


		} catch (com_exception $e)  {
			throw new Exception(iconv('windows-1251', 'utf-8', $e->getMessage()) . '. Code: 0x' . dechex($e->getCode()) . '; File: ' . $e->getFile() . ' at line ' . $e->getLine());
		}
	}

	public function __get($name) {
		if (method_exists ($this, $m="get_$name") ) {
			return $this->$m();
		} else {
			return $this->_OLEGetProperty($name);
		}
		trigger_error("Class method get_$name() not found.");
    }

	public function __set($name, $value) {
        if (method_exists ($this, $m="set_$name")) {
            return $this->$m($value);
        } else {
			return $this->_OLESetProperty($name, $value);
		}
        trigger_error("Class method set_$name(\$value) not found.");
    }

    public function __call($name, $arguments) {

		if (method_exists ($this, $name)) {
			//$this->$name($arguments);
		} else {
			try {
				return call_user_func(array($this, '_OLEInvokeMethod'), $name, $arguments);
			} catch (com_exception $e) {
				echo ('OLE-object error: ' . $this->__progID.
				'. ErrorCode: ' . $e->getCode() .
				'; errorMessage: ' . $e->getMessage() .
				'; errorFile: ' . $e->getFile() .
				'; errorLine: ' . $e->getLine() .
				'; Method call: ' . $name . '(' . implode(',', $arguments) . ')'
				);
				throw new Exception('OLE error');
			}

		}

    }

}
