<?php

/**

Базовый модуль для работы с дисплеями покупателя

Для просмотра всех функций модуля используйте запрос типа:
  http://api.server.com/api.php?a=pinpad:sbrf:Describe

*/

require 'device.php';

// Коды возврата, определенные в DEVICE.PHP
//DEFINE ('EC_DEVICE_ERROR', 'DEVICE_ERROR'); //Ошибка в устройстве. Например, потеряна связь. Надо устранить ошибку и повторить операцию

// Коды возврата для терминала оплаты

/* Абстрактный класс для работы с терминалом оплаты */
class Pinpad extends Device {
	
	const EC_PARAM_ERROR = 'PARAM_ERROR';
	const EC_AMOUNT_MISTAKE = 'AMOUNT_MISTAKE';
	
	/**
	 * Список умений данного устройства
	 * 
	 */
	private $_actions = array(
			'pay'					=> array(),	// (4000) Оплата покупки
			'payCansel'				=> array(),	// (4003) Отмена операции
			'payWithTransaction'	=> array(),	// (6003) Установить транзакцию в «неподтвержденное» состояние
			'payTransactionCommit'	=> array(),	// (6001) Установить транзакцию в «подтвержденное» состояние
			'payTransactionCansel'	=> array(),	// (6003) Отменить транзакцию немедленно
			'closeShift'			=> array(),	// (6000) Отменить транзакцию немедленно
			'xReport'				=> array(),	// (6002) Отчет по картам с магнитной полосов (не закрывает смену)
		);
	
	/**
	 * Возвращает список действий, которые умеет выполнять данное устройство
	 * 
	 * @param
	 * @return array
	 */
	protected function _getActionList(){
		return $this->_actions;
	}
	
	/************************************************/
	/* DISPLAY ACTIONS METHODS */
	
	/**
	 * Оплата покупки
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_pay($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }
	
	/**
	 * Отмена операции
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_payCansel($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }
	
	/**
	 * Произвести платеж и установить транзакцию в «неподтвержденное» состояние
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_payWithTransaction($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }

        /**
	 * Установить транзакцию в «подтвержденное» состояние
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_payTransactionCommit($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }
	
	/**
	 * Отменить транзакцию немедленно
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_payTransactionCansel($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }
	
	/**
	 * Закрытие смены
	 * @param type $params
	 * @return boolean
	 */
	protected function _do_closeShift($params)
	{
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }
	
	/**
	 * Отчет по картам с магнитной полосов (не закрывает смену)
	 * @param type $params
	 * @return boolean
	 */
        protected function _do_xReport($params) {
            return array(
                'success' => false,
                'errcode' => 1,
                'error' => 'Метод не поддерживается',
            );
        }

    /************************************************/
	
	/**
	 * Оплата покупки
	 * @param type $params
	 */
	public function  Pay($params)
	{
		return $this->_do_pay($params);
	}
	
	/**
	 * Отмена операции
	 * @param type $params
	 */
	public function  PayCansel($params)
	{
		return $this->_do_payCansel($params);
	}
	
	/**
	 * Установить транзакцию в «неподтвержденное» состояние
	 * @param type $params
	 */
	public function  PayWithTransaction($params)
	{
		return $this->_do_payWithTransaction($params);
	}
	
	/**
	 * Установить транзакцию в «подтвержденное» состояние
	 * @param type $params
	 */
	public function  PayTransactionCommit($params)
	{
		return $this->_do_payTransactionCommit($params);
	}
	
	/**
	 * Отменить транзакцию немедленно
	 * @param type $params
	 */
	public function  PayTransactionCansel($params)
	{
		return $this->_do_payTransactionCansel($params);
	}
	
	/**
	 * Отменить транзакцию немедленно
	 * @param type $params
	 */
	public function  CloseShift($params)
	{
		return $this->_do_closeShift($params);
	}
	
	/**
	 * Отчет по картам с магнитной полосов (не закрывает смену)
	 * @param type $params
	 */
	public function XReport($params)
	{
		return $this->_do_xReport($params);
	}
}