<?php

/**
Базовый модуль для работы с весами
*/

require 'device.php';


/* Абстрактный класс для работы с весами */
class Scale extends Device {

	/**
	 * Список умений данного устройства
	 *
	 */
	private $_actions = array(
        'init'      => array(), /* Инициализирует весы */
        'reset'     => array(), /* Очистка состояния весов */
        'weight'    => array(), /* Возвращает вес на чаше весов */
        'test'      => array(), /* Проверка работы весов */
    );

	/**
	 * Возвращает список действий, которые умеет выполнять данное устройство
	 *
	 * @param
	 * @return array
	 */
	protected function _getActionList(){
		return $this->_actions;
	}

	/************************************************/
	/* DISPLAY ACTIONS METHODS */

	/**
	 * Инициализирует весы
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_init($params){
		return true;
	}

	/**
	 * Очищает состояние весов
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_reset($params){
		return true;
	}

	/**
	 * Возвращает вес груза на весах
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_weight($params){
		return true;
	}

	/**
	 * Инициализация весов
	 *
	 * @param
	 * @return
	 */
	public function Init($params) {
		return $this->_doAction('init', $params);
	}

	/**
	 * Очистка экрана дисплея
	 *
	 * @param
	 * @return
	 */
	public function Reset($params) {
		return $this->_doAction('reset', $params);
	}

	/**
	 * Вернуть вес на весах
	 *
	 * @param array $params Массив параметров.
	 * @return
	 */
	public function Weight($params) {
		return $this->_doAction('weight', $params);
	}
}
