<?php

require 'core/FiscalPrinter.php';
require 'fp_atol_native.php';
require 'fp_atol_errors.php';
require 'fp_atol_utils.php';

//
// пароли
DEFINE('FP_PASSWORD_STD', '6');   // не испльзуеться. используем рутовый доступ всегда
DEFINE('FP_PASSWORD_ADMIN', '29');  // не испльзуеться. используем рутовый доступ всегда
DEFINE('FP_PASSWORD_SYSADMIN', '30');

DEFINE('FP_DEFAULT_DEPARTMENT', '0');

//
// режимы ККМ
DEFINE('FR_ECRMode_READY_FOR_PRINT', '0');   //Принтер в рабочем режиме
//
// подрежимы ККМ
DEFINE('FR_ECRAdvMode_OK', '0');  //  Бумага есть– ФР не в фазе печати операции– может принимать от хоста команды, связанные с печатью на том ленте, датчик которой сообщает о наличии бумаги.

/* The goal of this class is translate standard interface methods to native driver calls */

class fiscalprinter_atol extends FiscalPrinter {

    const ERROR_24HOUR = '-3822';
    const MODE_WAIT = 0;
    const MODE_WREGISTRATE = 1;
    const MODE_XREPORT = 2;
    const MODE_ZREPORT = 3;

    /**
     * Используется для совместимости со старыми версиями VirtualPos и старыми чеками при возвратах в новом VirtualPos
     * @var type
     */
    private $isLegacyMode = false;
    /**
     * Тип чека - открытие или закрытие. Обычно 1 и 2.
     * @var type Integer
     */
    private $checkType;
    private $vatBunchBeforeCloseCheck = null;
    private $moneyProfitBeforeCloseCheck = 0;
    private $config = null;
    // секция координат автора чека
    private $operatorPassword = 30;
    private $operatorCaptionPurpose = 118;

    // секция значений дополнительного конфига по умолчанию
    const VAT_NAME_DEFAULT_0 = 1;
    const VAT_NAME_DEFAULT_10 = 2;
    const VAT_NAME_DEFAULT_18 = 3; // оставлено для обратной совместимости
    const VAT_NAME_DEFAULT_20 = 3;
    const VAT_NAME_DEFAULT_NO = 4;
    const PAYMENT_TYPE_DEFAULT_CASH = 0;
    const PAYMENT_TYPE_DEFAULT_CREDIT = 3;
    const PAYMENT_TYPE_DEFAULT_TARE = 2;
    const PAYMENT_TYPE_DEFAULT_CARD = 5;
    const PAYMENT_TYPE_DEFAULT_COUPON = 4;
    const PRINT_TAX_NUMBER_NO_DEFAULT = 0;
    // секция названий параметров
    const VAT_NAME_0 = 'vat_number_0';
    const VAT_NAME_10 = 'vat_number_10';
    const VAT_NAME_18 = 'vat_number_18';
    const VAT_NAME_20 = 'vat_number_20';
    const VAT_NAME_NO = 'vat_number_no';
    const PAYMENT_TYPE_CASH = 'payment_type_cash';
    const PAYMENT_TYPE_CREDIT = 'payment_type_credit';
    const PAYMENT_TYPE_TARE = 'payment_type_tare';
    const PAYMENT_TYPE_CARD = 'payment_type_card';
    const PAYMENT_TYPE_COUPON = 'payment_type_coupon';
    const PRINT_TAX_NUMBER_NO = 'print_tax_number_no';

    /**
     * Beep команда
     * @return array
     */
    public function Beep() {
        $device = $this->get_NativeDevice();

        $result = $device->Beep();

        if ($result == 0) {
            return array('success' => true);
        } else {
            return array('success' => false, 'error' => $this->_internalGetLastErrorMessage());
        }
    }

    /**
     * Beep команда
     * @return array
     */
    public function Sound() {
        $device = $this->get_NativeDevice();

        require_once dirname(__FILE__) . '/fp_sound.php';
        kuznechik($device);
        $result = 0;

        if ($result == 0) {
            return array('success' => true);
        } else {
            return array('success' => false, 'error' => $this->_internalGetLastErrorMessage());
        }
    }

    /**
     * Получить инфомацию о ФР
     */
    public function GetInfo($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        if (isset($params['dateTime'])) {
            $time = strtotime($params['dateTime']);
            $device->Hour = date('H', $time);
            $device->Minute = date('i', $time);
            $device->Second = date('s', $time);
//		    $device->SetTime();	// устанавливаем, не проверяем. Если находимся в правильном режиме сменем или время не сменится
        }

        // запрос статуса
        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $EKLZExist = $device->Fiscal;  //$device->EKLZIsPresent;
        $ECRMode = $device->Mode;   //$deice->ECRMode8Status;
        // TODO: надо перевести статусы
        $ECRModeDesc = 'Неизвестный режим';   //iconv('windows-1251', 'utf-8', $device->ECRModeDescription);
        $ECRMode8Status = $device->CheckState;   //$device->ECRMode8Status;
        $ECRModeStatus = $device->Mode;  //$device->ECRModeStatus;
        $ECRAdvancedMode = $device->AdvancedMode;  //$device->ECRAdvancedMode;
        // TODO: надо перевести статусы
        $ECRAdvancedModeDesc = 'Неизвестный подрежим'; //iconv('windows-1251', 'utf-8', $device->ECRAdvancedModeDescription);
        $SerialNumber = str_pad($device->SerialNumber, 8, '0', STR_PAD_LEFT); //$device->SerialNumber;
        $LastSessionNumber = $device->Session + 1;   //$device->SessionNumber;
        $Date = "{$device->Day}.{$device->Month}.{$device->Year}"; //$device->Date;
        $Time = "{$device->Hour}:{$device->Minute}:{$device->Second}"; //$device->Time;
        //
		// запрос номеров документов
        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // получить номера чеков
        $LastGlobalDocNumber = $device->DocNumber;  //$device->OpenDocumentNumber;
        $LastCheckNumber = $this->getCheckNumber($device);  //$device->ContentsOfOperationRegister;
        // запрос ИНН
        $device->RegisterNumber = 27;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $INN = $this->getInn();
        $MachineNumber = $this->_internalGetMachineNumber($device);

        $result = array('success' => true,
            'INN' => $INN,
            'LastGlobalDocNumber' => $LastGlobalDocNumber,
            'LastCheckNumber' => $LastCheckNumber,
            'EKLZExist' => $EKLZExist,
            'ECRMode' => $ECRMode,
            'ECRModeDesc' => $ECRModeDesc,
            'ECRMode8Status' => $ECRMode8Status,
            'ECRModeStatus' => $ECRModeStatus,
            'ECRAdvancedMode' => $ECRAdvancedMode,
            'ECRAdvancedModeDesc' => $ECRAdvancedModeDesc,
            'SerialNumber' => $SerialNumber,
            'MachineNumber' => $MachineNumber,
            'LastSessionNumber' => $LastSessionNumber,
            'Date' => date('d.m.Y', time($Date)),
            'Time' => time($Time),
        );

        $this->log(__METHOD__ . " ----- end. OK. " . json_encode($result, JSON_UNESCAPED_UNICODE) . " \n", 3);
        return $result;
    }

    public function ContinuePrintSupport() {
        return false;
    }

    protected function beforeCheckPrintArray($lines) {
        $device = $this->get_NativeDevice();
        $isSessionOpened = $this->isSessionOpened($device);
        $hasOpenCheck = false;
        $operatorName = null;
        foreach ($lines as $line) {
            if ($line['action'] === 'opencheck') {
                $hasOpenCheck = true;
                if (isset($line['params'], $line['params']['operatorName'])) {
                    $operatorName = $line['params']['operatorName'];
                }
                break;
            }
            }
        if (!$isSessionOpened && $hasOpenCheck) {
            $this->log(__METHOD__ . " ----- open session in beforeCheckPrintArray\n", 3);
            if (isset($operatorName) && !empty($operatorName)) {
                $this->setOperatorName($operatorName);
                $device->Mode = 1;
                $device->OperatorPassword = $this->operatorPassword;
                $result = $device->SetMode();
            } else {
                $device->Mode = 1;
                $result = $device->SetMode();
            }
            $result = $device->OpenSession();
            $feedParams['linesQuantity'] = 5;
            $this->_do_feed($feedParams);
            $this->_do_cut();
        }
    }

    protected function isCheckPrintArrayConvertingRequired($isLegacy) {
        $this->isLegacyMode = $isLegacy;
        return true;
    }

    /**
     * Заменяет все команды discount на команды print, а сумму скидки из убранных команд discount добавляет в miscDiscount
     * @param type $lines
     * @return type
     */
    protected function convertCheckPrintArray($lines) {
        if ($this->isLegacyMode) {
            return $this->legacyConvertCheckPrint($lines);
        } else {
            return $this->finalDiscountConvertCheckPrint($lines);
        }
    }

    /**
     * Метод печатает сменный отчет
     *
     * @params['withcleaning'] bool - если true, то отчет с гашением
     * @return
     */
    public function PrintReport($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);
        if (!isset($params['withcleaning'])) {
            $this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр [withcleaning]\n", 1);
            return array('success' => false, 'error' => 'Не передан обязательный параметр [withcleaning]');
        }
        $clean = ($params['withcleaning'] != 0);

        /*
          Операционные регистры:
          144.Количество чеков продаж в смене
          145.Количество чеков покупок в смене
          146.Количество чеков возврата продаж в смене
          147.Количество чеков возврата покупок в смене

          Денежные регистры:
          245.Сумма продаж в смене из ЭКЛЗ
          246.Сумма покупок в смене из ЭКЛЗ
          247.Сумма возвратов продаж в смене из ЭКЛЗ
          248.Сумма возвратов покупок в смене из ЭКЛЗ
          249.Сумма аннулированных продаж в смене
          250.Сумма аннулированных покупок в смене
          251.Сумма аннулированных возвратов продаж в смене
          252.Сумма аннулированных возвратов покупок в смене
         */
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $totalSalesCheckCount = $this->getCheckNumber($device);
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // проверка того может ли принтер напечатать очередной чек (игнорируем блок 24 часа)
        $result = $this->ReadyForNewCheck(true);
        if (!$result['success']) {
            $this->log(__METHOD__ . " ----- end. Result = fail. Принтер не готов к печати нового чека. result=" . json_encode($result, JSON_UNESCAPED_UNICODE) . "\n", 1);
            return $result;
        }

        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        $docNumber = $device->DocNumber;

        $device->CancelCheck();
        if ($clean) {
            $this->log(__METHOD__ . " Запуск снятия отчета с гашением", 3);
            if (isset($params['operatorName']) && !empty($params['operatorName'])) {
                $this->setOperatorName($params['operatorName']);
                $device->Mode = 3;
                $device->OperatorPassword = $this->operatorPassword;
                $device->Password = FP_PASSWORD_SYSADMIN;
                $device->SetMode();
            } else {
                $device->Mode = 3;
                $device->Password = FP_PASSWORD_SYSADMIN;
                $device->SetMode();
            }
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;

            $device->ReportType = 1;
            $device->Report();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }
        else {
            $this->log(__METHOD__ . " Запуск снятия отчета без гашения", 3);
            $device->Mode = 2;
            $device->Password = FP_PASSWORD_SYSADMIN;
            $device->SetMode();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;

            $device->ReportType = 2;
            $device->Report();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        $this->_waitWhilePrinting();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $device->RegisterNumber = 12;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        $totalSalesAmount = $device->Summ;

        $device->RegisterNumber = 21;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        $session = $device->Session;

        $machineNumber = $this->_internalGetMachineNumber($device);

        $serial = $this->_internalGetSerialNumber();
        $datetime = $this->_internalGetDateTime();

        if ($clean) {
            //$this->log(__METHOD__ . " Запуск снятия отчета с гашением", 3);
            return array('success' => true, 'globalchecknum' => $docNumber, 'salesamount' => $totalSalesAmount, 'saleschecks' => $totalSalesCheckCount, 'session' => $session, 'serial' => $serial, 'MachineNumber' => $machineNumber, 'datetime' => $datetime);
        } else {
            //$this->log(__METHOD__ . " Запуск снятия отчета без гашения", 3);
            $xreportNumber = $docNumber; // в атол такого регистра нет
            return array('success' => true, 'globalchecknum' => $docNumber, 'xreportNumber' => 0, 'salesamount' => $totalSalesAmount, 'saleschecks' => $totalSalesCheckCount, 'session' => $session, 'serial' => $serial, 'MachineNumber' => $machineNumber, 'datetime' => $datetime);
        }
    }

    /**
     * Возвращает дату и время фискального регистратора
     *
     * @param
     * @return
     */
    protected function _internalGetDateTime($dev = NULL) {
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $device->RegisterNumber = 17;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $day = str_pad($device->Day, 2, '0', STR_PAD_LEFT);
        $month = str_pad($device->Month, 2, '0', STR_PAD_LEFT);

        $hour = str_pad($device->Hour, 2, '0', STR_PAD_LEFT);
        $minute = str_pad($device->Minute, 2, '0', STR_PAD_LEFT);
        $second = str_pad($device->Second, 2, '0', STR_PAD_LEFT);

        $Date = "{$day}.{$month}.{$device->Year}";
        $Time = "{$hour}:{$minute}:{$second}";

        return "$Date $Time";
    }

    /**
     * Возвращает серийный номер фискального регистратора
     *
     * @param
     * @return
     */
    protected function _internalGetSerialNumber($dev = NULL) {

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $device->RegisterNumber = 22;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        return str_pad($device->SerialNumber, 8, '0', STR_PAD_LEFT);
    }

    /**
     * Возвращает регистрационный номер фискального регистратора
     *
     * @param
     * @return
     */
    protected function _internalGetMachineNumber($dev = NULL) {
        if (is_null($dev)) {
            $dev = $this->get_NativeDevice();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }
        $dev->AttrNumber = 1037;
        $dev->ReadAttribute();
        $result = $dev->AttrValue;
        return trim($result);
    }

    /**
     * Получает информацию о смене
     */
    public function GetShiftInfo() {
        $this->log(__METHOD__ . " ----- start\n", 3);
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $paymentTypeCash = $this->config->getParameter(self::PAYMENT_TYPE_CASH, self::PAYMENT_TYPE_DEFAULT_CASH);
        $paymentTypeCredit = $this->config->getParameter(self::PAYMENT_TYPE_CREDIT, self::PAYMENT_TYPE_DEFAULT_CREDIT);
        $paymentTypeTare = $this->config->getParameter(self::PAYMENT_TYPE_TARE, self::PAYMENT_TYPE_DEFAULT_TARE);
        $paymentTypeCard = $this->config->getParameter(self::PAYMENT_TYPE_CARD, self::PAYMENT_TYPE_DEFAULT_CARD);
        $paymentTypeCoupon = $this->config->getParameter(self::PAYMENT_TYPE_COUPON, self::PAYMENT_TYPE_DEFAULT_COUPON);

        $taxNumber0 = $this->config->getParameter(self::VAT_NAME_0, self::VAT_NAME_DEFAULT_0);
        $taxNumber10 = $this->config->getParameter(self::VAT_NAME_10, self::VAT_NAME_DEFAULT_10);
        $taxNumber18 = $this->config->getParameter(self::VAT_NAME_18, self::VAT_NAME_DEFAULT_18);
        $taxNumber20 = $this->config->getParameter(self::VAT_NAME_20, self::VAT_NAME_DEFAULT_20);
        $taxNumberNo = $this->config->getParameter(self::VAT_NAME_NO, self::VAT_NAME_DEFAULT_NO);

        /*
          CheckType
          ТипЧека
          Int RW
          Тип чека:
           1 – продажа;
           2 – возврат продажи;
           3 – аннулирование продажи;
           4 – покупка;
           5 – возврат покупки;
           6 – аннулирование покупки


          TypeClose
          ТипЗакрытия
          Int RW
          Тип закрытия чека:
           0 - наличными;
           1 - тип оплаты 1;
           2 - тип оплаты 2;
         */

        // === ЧЕКОВ ПРОДАЖ ===
        // ==============================================================
        $device->RegisterNumber = 6;
        $device->CheckType = 1;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_SALE_COUNTS\n", 1);
            $registers['REG_OPER_SALE_COUNTS'] = 0;
        } else {
            $registers['REG_OPER_SALE_COUNTS'] = $device->Count;
        }

        $device->RegisterNumber = 1;
        $device->CheckType = 1;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM\n", 1);
            $registers['REG_CASH_SALE_SUM'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 1;
        $device->TypeClose = $paymentTypeCash;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM_CASH\n", 1);
            $registers['REG_CASH_SALE_SUM_CASH'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM_CASH'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 1;
        $device->TypeClose = $paymentTypeCredit;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM_CREDIT\n", 1);
            $registers['REG_CASH_SALE_SUM_CREDIT'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM_CREDIT'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 1;
        $device->TypeClose = $paymentTypeTare;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM_TARE\n", 1);
            $registers['REG_CASH_SALE_SUM_TARE'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM_TARE'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 1;
        $device->TypeClose = $paymentTypeCard;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM_CARD\n", 1);
            $registers['REG_CASH_SALE_SUM_CARD'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM_CARD'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 1;
        $device->TypeClose = $paymentTypeCoupon;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALE_SUM_CARD\n", 1);
            $registers['REG_CASH_SALE_SUM_COUPON'] = 0;
        } else {
            $registers['REG_CASH_SALE_SUM_COUPON'] = $device->Summ;
        }

        // === Чеков покупок ===
        // ==============================================================
        $device->RegisterNumber = 6;
        $device->CheckType = 4;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_BUY_COUNTS\n", 1);
            $registers['REG_OPER_BUY_COUNTS'] = 0;
        } else {
            $registers['REG_OPER_BUY_COUNTS'] = $device->Count;
        }

        $device->RegisterNumber = 1;
        $device->CheckType = 4;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUY_SUM\n", 1);
            $registers['REG_CASH_BUY_SUM'] = 0;
        } else {
            $registers['REG_CASH_BUY_SUM'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 4;
        $device->TypeClose = $paymentTypeCash;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUY_SUM_CASH\n", 1);
            $registers['REG_CASH_BUY_SUM_CASH'] = 0;
        } else {
            $registers['REG_CASH_BUY_SUM_CASH'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 4;
        $device->TypeClose = $paymentTypeCredit;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUY_SUM_CREDIT\n", 1);
            $registers['REG_CASH_BUY_SUM_CREDIT'] = 0;
        } else {
            $registers['REG_CASH_BUY_SUM_CREDIT'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 4;
        $device->TypeClose = $paymentTypeTare;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUY_SUM_TARE\n", 1);
            $registers['REG_CASH_BUY_SUM_TARE'] = 0;
        } else {
            $registers['REG_CASH_BUY_SUM_TARE'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 4;
        $device->TypeClose = $paymentTypeCard;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUY_SUM_CARD\n", 1);
            $registers['REG_CASH_BUY_SUM_CARD'] = 0;
        } else {
            $registers['REG_CASH_BUY_SUM_CARD'] = $device->Summ;
        }

        // === Чеков возвратов продаж ===
        // ==============================================================
        $device->RegisterNumber = 6;
        $device->CheckType = 2;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_SALERET_COUNTS\n", 1);
            $registers['REG_OPER_SALERET_COUNTS'] = 0;
        } else {
            $registers['REG_OPER_SALERET_COUNTS'] = $device->Count;
        }

        $device->RegisterNumber = 1;
        $device->CheckType = 2;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALERET_SUM\n", 1);
            $registers['REG_CASH_SALERET_SUM'] = 0;
        } else {
            $registers['REG_CASH_SALERET_SUM'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 2;
        $device->TypeClose = $paymentTypeCash;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALERET_SUM_CASH\n", 1);
            $registers['REG_CASH_SALERET_SUM_CASH'] = 0;
        } else {
            $registers['REG_CASH_SALERET_SUM_CASH'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 2;
        $device->TypeClose = $paymentTypeCredit;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALERET_SUM_CREDIT\n", 1);
            $registers['REG_CASH_SALERET_SUM_CREDIT'] = 0;
        } else {
            $registers['REG_CASH_SALERET_SUM_CREDIT'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 2;
        $device->TypeClose = $paymentTypeTare;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALERET_SUM_TARE\n", 1);
            $registers['REG_CASH_SALERET_SUM_TARE'] = 0;
        } else {
            $registers['REG_CASH_SALERET_SUM_TARE'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 2;
        $device->TypeClose = $paymentTypeCard;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_SALERET_SUM_CARD\n", 1);
            $registers['REG_CASH_SALERET_SUM_CARD'] = 0;
        } else {
            $registers['REG_CASH_SALERET_SUM_CARD'] = $device->Summ;
        }

        // === Чеков возвратов продаж ===
        // ==============================================================
        $device->RegisterNumber = 6;
        $device->CheckType = 5;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_BUYRET_COUNTS\n", 1);
            $registers['REG_OPER_BUYRET_COUNTS'] = 0;
        } else {
            $registers['REG_OPER_BUYRET_COUNTS'] = $device->Count;
        }

        $device->RegisterNumber = 1;
        $device->CheckType = 5;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUYRET_SUM\n", 1);
            $registers['REG_CASH_BUYRET_SUM'] = 0;
        } else {
            $registers['REG_CASH_BUYRET_SUM'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 5;
        $device->TypeClose = $paymentTypeCash;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUYRET_SUM_CASH\n", 1);
            $registers['REG_CASH_BUYRET_SUM_CASH'] = 0;
        } else {
            $registers['REG_CASH_BUYRET_SUM_CASH'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 5;
        $device->TypeClose = $paymentTypeCredit;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUYRET_SUM_CREDIT\n", 1);
            $registers['REG_CASH_BUYRET_SUM_CREDIT'] = 0;
        } else {
            $registers['REG_CASH_BUYRET_SUM_CREDIT'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 5;
        $device->TypeClose = $paymentTypeTare;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUYRET_SUM_TARE\n", 1);
            $registers['REG_CASH_BUYRET_SUM_TARE'] = 0;
        } else {
            $registers['REG_CASH_BUYRET_SUM_TARE'] = $device->Summ;
        }

        $device->RegisterNumber = 3;
        $device->CheckType = 5;
        $device->TypeClose = $paymentTypeCard;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_BUYRET_SUM_CARD\n", 1);
            $registers['REG_CASH_BUYRET_SUM_CARD'] = 0;
        } else {
            $registers['REG_CASH_BUYRET_SUM_CARD'] = $device->Summ;
        }

        // === Внесений ===
        // ==============================================================

        $device->RegisterNumber = 8;
        $device->GetRegister();
        $registers['REG_OPER_MONEYINPUT_COUNT_GLOBAL'] = -1;
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_MONEYINPUT_COUNT\n", 1);
            $registers['REG_OPER_MONEYINPUT_COUNT'] = 0;
        } else {
            $registers['REG_OPER_MONEYINPUT_COUNT'] = $device->Count;
        }

        $device->RegisterNumber = 4;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_MONEYINPUT_SUM\n", 1);
            $registers['REG_CASH_MONEYINPUT_SUM'] = 0;
        } else {
            $registers['REG_CASH_MONEYINPUT_SUM'] = $device->Summ;
        }

        // === Выплат ===
        // ==============================================================

        $device->RegisterNumber = 9;
        $device->GetRegister();
        $registers['REG_OPER_MONEYOUTPUT_COUNT_GLOBAL'] = -1;
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_OPER_MONEYOUTPUT_COUNT\n", 1);
            $registers['REG_OPER_MONEYOUTPUT_COUNT'] = 0;
        } else {
            $registers['REG_OPER_MONEYOUTPUT_COUNT'] = $device->Count;
        }

        $device->RegisterNumber = 5;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_MONEYOUTPUT_SUM\n", 1);
            $registers['REG_CASH_MONEYOUTPUT_SUM'] = 0;
        } else {
            $registers['REG_CASH_MONEYOUTPUT_SUM'] = $device->Summ;
        }

        // === Аннуляция ===
        // ==============================================================

        $registers['REG_OPER_ANNULATE_COUNT_GLOBAL'] = -1;
        $registers['REG_OPER_ANNULATE_SALE_COUNT'] = -1;
        $registers['REG_CASH_ANNULATE_SALE_SUM'] = -1;
        $registers['REG_OPER_ANNULATE_BUY_COUNT'] = -1;
        $registers['REG_CASH_ANNULATE_BUY_SUM'] = -1;
        $registers['REG_OPER_ANNULATE_SALERET_COUNT'] = -1;
        $registers['REG_CASH_ANNULATE_SALERET_SUM'] = -1;
        $registers['REG_OPER_ANNULATE_BUYRET_COUNT'] = -1;
        $registers['REG_CASH_ANNULATE_BUYRET_SUM'] = -1;

//        $device->RegisterNumber = 31;
//        $device->CheckType = 1;
//        $device->TaxTypeNumber = $taxNumber10;
//        $device->GetRegister();
//        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
//            $this->log(__METHOD__ . "REG_CASH_VAT_10\n", 1);
//            $registers['REG_CASH_VAT_10'] = 0;
//        } else {
//            $registers['REG_CASH_VAT_10'] = $device->Summ;
//        }
//        $device->RegisterNumber = 31;
//        $device->CheckType = 1;
//        $device->TaxTypeNumber = $taxNumber18;
//        $device->GetRegister();
//        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
//            $this->log(__METHOD__ . "REG_CASH_VAT_18\n", 1);
//            $registers['REG_CASH_VAT_18'] = 0;
//        } else {
//            $registers['REG_CASH_VAT_18'] = $device->Summ;
//        }
//        $device->RegisterNumber = 31;
//        $device->CheckType = 1;
//        $device->TaxTypeNumber = $taxNumber20;
//        $device->GetRegister();
//        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
//            $this->log(__METHOD__ . "REG_CASH_VAT_20\n", 1);
//            $registers['REG_CASH_VAT_20'] = 0;
//        } else {
//            $registers['REG_CASH_VAT_20'] = $device->Summ;
//        }

        $device->RegisterNumber = 10;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_ALLCASH_SUM\n", 1);
            $registers['REG_CASH_ALLCASH_SUM'] = 0;
        } else {
            $registers['REG_CASH_ALLCASH_SUM'] = $device->Summ;
        }

        $device->RegisterNumber = 14; //Необнуляемая сумма после последней перерегистрации + сменный итог текущей смены
        $device->OperationType = 0;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "REG_CASH_ALLCASH_SUM\n", 1);
            $registers['REG_CASH_TOTAL_SALE_SUM'] = 0;
        } else {
            $registers['REG_CASH_TOTAL_SALE_SUM'] = $device->Summ;
        }

        $registers['REG_OPER_SALE_COUNTS_DISCOUNT'] = "0";
        $registers['REG_CASH_SALE_SUM_DISCOUNT'] = "0";

        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // запрос по всем требующимся регистрам
        $result = array(
            'success' => true,
            'IsFMSessionOpen' => $device->SessionOpened,
            'IsFM24HoursOver' => false,
            'SessionNumber' => $device->Session + 1,
            'INN' => $this->getInn(),
            'registers' => $registers,
        );

        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "OpenDocumentNumber\n", 1);
            $result['OpenDocumentNumber'] = 0;
        } else {
            $result['OpenDocumentNumber'] = $device->DocNumber;
        }

        $this->log(__METHOD__ . " ----- end. OK. " . json_encode($result, JSON_UNESCAPED_UNICODE) . " \n", 3);
        return $result;
    }

    /**
     * Возвращает success=true в том случае, если принтер готов напечатать новый чек
     *
     * @param
     * @return
     */
    public function ReadyForNewCheck($ignoreSession = false) {
        $this->log(__METHOD__ . " - start\n", 3);
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        if (!$this->_checkPaper()) {
            $this->log(__METHOD__ . " ----- end. Fail. Нет бумаги\n", 3);
            return array(
                'success' => false,
                'error' => 'Закончилась бумага. Вставьте новую ленту и повторите операцию.',
                'errcode' => EC_NO_PAPER,
                'ecrmode' => $device->Mode,
                'ecradvmode' => $device->AdvancedMode
            );
        }

        if (!$ignoreSession) {
            $device->Mode = 1;
            $result = $device->SetMode();
            if ($result == self::ERROR_24HOUR) {
                return $this->createSession24BlockResponse();
            }
        }
        return array('success' => true);
    }

    /**
     * Метод регистрирует внесение денежной суммы в кассу.
     *
     * @param['amount'] - сумма внесения в рублях
     * @return
     */
    public function CashIncome($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);

        if (!isset($params['amount']) || !is_numeric($params['amount'])) {
            $this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр amount.\n", 1);
            return array('success' => false, 'error' => 'Не передан обязательный параметр amount', 'errcode' => EC_API_ERROR);
        }
        $amount = floatval($params['amount']);

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $this->printOrganizationBatch($params);

        $device->Mode = 1;
        $device->SetMode();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $session = $device->Session + 1;

        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $docNumber = $device->DocNumber;

        $device->Summ = $amount;
        $device->CashIncome();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // режем
        $this->_do_feed(array('linesQuantity' => 8));
        $this->_do_cut();


        $device->RegisterNumber = 8;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $incomeNumber = $device->Count;
        $incomeNumberGlobal = -1;

        $serial = $this->_internalGetSerialNumber();
        $datetime = $this->_internalGetDateTime();

        $this->log(__METHOD__ . " ----- end. OK. Amount: {$amount}, DocNumber: {$docNumber}\n", 3);
        return array('success' => true, 'amount' => $amount, 'globalchecknum' => $docNumber, 'incomeNumber' => $incomeNumber, 'incomeNumberGlobal' => $incomeNumberGlobal, 'serial' => $serial, 'session' => $session, 'datetime' => $datetime);
    }

    /**
     * Метод регистрирует выплату из кассы денежной суммы
     *
     * @param['amount'] - сумма выплаты в рублях
     * @return
     */
    public function CashOutcome($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);

        if (!isset($params['amount']) || !is_numeric($params['amount'])) {
            $this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр amount.\n", 1);
            return array('success' => false, 'error' => 'Не передан обязательный параметр amount', 'errcode' => EC_API_ERROR);
        }
        $amount = floatval($params['amount']);

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $this->printOrganizationBatch($params);

        $device->Mode = 1;
        $device->SetMode();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $session = $device->Session + 1;

        $device->RegisterNumber = 19;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $docNumber = $device->DocNumber;

        $device->Summ = $amount;
        $device->CashOutcome();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // режем
        $this->_do_feed(array('linesQuantity' => 8));
        $this->_do_cut();

        $device->RegisterNumber = 9;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;
        $outcomeNumber = $device->Count;
        $outcomeNumberGlobal = -1;

        $serial = $this->_internalGetSerialNumber();
        $datetime = $this->_internalGetDateTime();
        $this->log(__METHOD__ . " ----- end. OK. Amount: {$amount}, DocNumber: {$docNumber}\n", 3);
        return array('success' => true, 'amount' => $amount, 'globalchecknum' => $docNumber, 'outcomeNumber' => $outcomeNumber, 'outcomeNumberGlobal' => $outcomeNumberGlobal, 'serial' => $serial, 'session' => $session, 'datetime' => $datetime);
    }

    /**
     * Функция ожидания завершения печати
     *
     * @param int $timeoutms Максимальное время ожидания в миллисекундах
     * @return bool возвращает true если устройство вышло из указанных режимов
     */
    protected function _waitWhilePrinting($timeoutms = 3000) {
        $this->log(__METHOD__ . " ----- start\n", 3);

        // про просто. Драйвер последовательный, ему нужна эта эмпирическая задержка
        usleep(10000);
        return false;
    }

    protected function _mapVatToTaxNumber($vatPercent) {
        $number0 = $this->config->getParameter(self::VAT_NAME_0, self::VAT_NAME_DEFAULT_0);
        $number10 = $this->config->getParameter(self::VAT_NAME_10, self::VAT_NAME_DEFAULT_10);
        $number18 = $this->config->getParameter(self::VAT_NAME_18, self::VAT_NAME_DEFAULT_18);
        $number20 = $this->config->getParameter(self::VAT_NAME_20, self::VAT_NAME_DEFAULT_20);
        $numberNo = $this->config->getParameter(self::VAT_NAME_NO, self::VAT_NAME_DEFAULT_NO);

        if ($vatPercent == 20) {
            return $number20;
        } elseif ($vatPercent == 18) {
            return $number18;
        } else if ($vatPercent == 10) {
            return $number10;
        } else if ($vatPercent == 0) {
            return $number0;
        } else if ($vatPercent == -1) {
            return $numberNo;
        } else {
            return 4;
        }
    }

    protected function _isTaxNumberNo($number) {
        $numberNo = $this->config->getParameter(self::VAT_NAME_NO, self::VAT_NAME_DEFAULT_NO);
        return $numberNo == $number;
    }

    /**
     * Печатает строку на чеке
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_print($params) {
        $this->log(__METHOD__ . " - start\n", 3);
        $str = $params['string'];

        $alignment = isset($params['alignment']) ? (int) $params['alignment'] : 1;

        $useJournalRibbon = true;
        if (isset($params['useJournalRibbon']))
            $useJournalRibbon = $params['useJournalRibbon'] === true;

        if (is_string($str)) {
            $device = $this->get_NativeDevice();

            /*
              Метод может вызываться в любом режиме, кроме режимов 11, 12 и 14 (см. свойство ECRMode).
             */
//            usleep(10000);
            //$device->UseJournalRibbon = $useJournalRibbon;
            $device->Caption = iconv('utf-8', 'windows-1251', $str); //$this->alignString(substr(iconv('utf-8', 'windows-1251', $str), 0, $device->SlipCharLineLength));
            $device->TextWrap = 0;
            $device->Alignment = $alignment; //работает только в протоколе АТОЛ 2.x
            $device->PrintString();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;

            $device->Caption = '';
//            $this->_waitWhilePrinting();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;

            if ($this->_checkPaper()) {
                return array('success' => true);
            } else {
                $this->log(__METHOD__ . " ----- ERROR Закончилась бумага \n", 1);
                return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
            }
        } else {
            $this->log(__METHOD__ . " ----- ERROR Неверный тип параметра для печати. Должен быть string \n", 1);
            return array('success' => false, 'error' => 'Неверный тип параметра для печати. Должен быть string');
        }
    }

    /**
     * Печатает строку на чеке с возможностью подстановки параметров
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_printex($params) {

        return array('success' => true, 'info' => 'Строки нет');

        while (strpos($params['string'], '@')) {
            if (strpos($params['string'], '@TOTAL_OPERATIONS')) {
                /*
                  $device = $this->get_NativeDevice();
                  if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

                  $device->RegisterNumber = 6;
                  $device->GetRegister();
                  if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

                  $qty = $device->Count;
                  $params['string'] = str_replace('@TOTAL_OPERATIONS', $qty, $params['string']);
                 */
                $params['string'] = '';
                break;
            } elseif (strpos($params['string'], '@POS_NUMBER')) { //Номер кассы в отделе
                /*
                  $device = $this->get_NativeDevice();
                  if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

                  $device->RegisterNumber = 27;
                  $device->GetRegister();
                  if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

                  $value = $device->MachineNumber;
                  $params['string'] = str_replace('@POS_NUMBER', $value, $params['string']);
                 */
                continue;
            } elseif (strpos($params['string'], '@CURRENT_CHECK_NUMBER')) { //Номер текущего чека
                $params['string'] = ''; // невозможно получить эту информацию. обнуляем строку
                break;
                /*
                  switch($device->CheckType){
                  case 0:
                  $checkRegister = self::REG_OPER_SALE_COUNTS;
                  break;
                  case 1:
                  $checkRegister = self::REG_OPER_BUY_COUNTS;
                  break;
                  case 2:
                  $checkRegister = self::REG_OPER_SALERET_COUNTS;
                  break;
                  case 3:
                  $checkRegister = self::REG_OPER_BUYRET_COUNTS;
                  break;
                  default:
                  $checkRegister = self::REG_OPER_SALE_COUNTS;
                  break;
                  }
                  $value = $this->_getOperationReg($checkRegister);
                  $value += 1;
                  $params['string'] = str_replace('@CURRENT_CHECK_NUMBER', $value, $params['string']);
                 */
            } else {
                break;
            }
            /*
              elseif (strpos($params['string'], '@MY_OPERATION')) {
              $value = 'my value';
              $params['string'] = str_replace('@MY_OPERATION', $value, $params['string']);
              } */
        }

        if ($params['string'] == '') {
            return array('success' => true, 'info' => 'Строки нет');
        } else {
            return $this->_do_print($params);
        }
    }

    /**
     * Печатает скидку на весь чек. Эта команда не может использоваться больше одного раза в одном открытом чеке!
     * Делать скидку на позицию в протоколе АТОЛ 3.x нельзя.
     *
     * Функция на самом деле не делает скидку после 54-ФЗ.
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_discount($params) {
        if (!$this->isLegacyMode) {
            return array('success' => true);
        }
        $this->log(__METHOD__ . " - start\n", 3);
        $discountAmount = $params['amount'];
        $discountDescription = $params['description'];
        if (!is_numeric($discountAmount)) {
            $this->log(__METHOD__ . " ----- ERROR Ошибка в сумме скидки: [$discountAmount] \n", 1);
            return array('success' => false, 'error' => "Ошибка в сумме скидки: [$discountAmount]", 'errcode' => EC_DEVICE_ERROR);
        }

        $printResult = $this->_do_print(array(
            'string' => $discountDescription
        ));
        if ($printResult['success']) {
            $device = $this->get_NativeDevice();

            $device->Summ = floatval($discountAmount);
            $device->Destination = 0;
            $device->DiscountTypeNumber = 0;
            $device->SummDiscount();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;

            if ($this->_checkPaper()) {
                return array('success' => true);
            } else {
                $this->log(__METHOD__ . " ----- ERROR Закончилась бумага \n", 1);
                return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
            }
        } else {
            return $printResult;
        }
    }

    /**
     * Открывает чек для добавления позиций
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_opencheck($params) {

        $this->log(__METHOD__ . " - start\n", 3);
        $device = $this->get_NativeDevice();
        $password = FP_PASSWORD_SYSADMIN;

        /*
           1 – продажа;
           2 – возврат продажи;
           3 – аннулирование продажи;
           4 – покупка;
           5 – возврат покупки;
           6 – аннулирование покупки
         */
        $this->checkType = isset($params['checktype']) ? $params['checktype'] : 1;
        $result = $device->NewDocument();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        if (isset($params['operatorName']) && !empty($params['operatorName'])) {
            $this->setOperatorName($params['operatorName']);
            $device->Mode = 1;
            $device->OperatorPassword = $this->operatorPassword;
            $result = $device->SetMode();
        } else {
            $device->Mode = 1;
            $result = $device->SetMode();
        }
        if ($result == self::ERROR_24HOUR) {
            return $this->createSession24BlockResponse();
        }

        $this->moneyProfitBeforeCloseCheck = $this->getMoneyProfit($device);
        $device->CheckType = $this->checkType;
        $result = $device->OpenCheck();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $this->_waitWhilePrinting();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;


	/************************************************************/
	/*Временное решение для смены системы налогообложения в чеке*/
	/************************************************************/
	$str = $params['customerContact'];
	if((strpos($str, '-') === 0) && (is_numeric ($val = substr($str, 1))) ){
        	$device->AttrNumber = 1055;
	        // Применяемая система налогооблажения в чеке:
        	// ОСН - 1
	        // УСН доход - 2
        	// УСН доход-расход - 4
	        // ЕНВД - 8
        	// ЕСН - 16
	        // ПСН - 32
        	$device->AttrValue = $val;
	        $device->WriteAttribute();
		$params['customerContact'] = '';
	}
	/***************************************/


        $this->vatBunchBeforeCloseCheck = $this->getVatBunch($device, $this->checkType);
        $regExpTemplate = '/[^A-Za-z0-9@\-\(\)\.\+\ \_]+/'; // поиск символов, отличных от тех, что в квадратных скобках
        if (isset($params['customerContact']) && !empty($params['customerContact']) && preg_match($regExpTemplate, $params['customerContact']) === 0) {
            $device->AttrValue = $params['customerContact'];
            $device->AttrNumber = 1008;
            $device->WriteAttribute();
        }

        return array('success' => true);
    }

    /**
     * Закрывает чек
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_closecheck($params) {
        $this->log(__METHOD__ . " - start\n", 3);
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $paymentTypeCash = $this->config->getParameter(self::PAYMENT_TYPE_CASH, self::PAYMENT_TYPE_DEFAULT_CASH);
        $paymentTypeCredit = $this->config->getParameter(self::PAYMENT_TYPE_CREDIT, self::PAYMENT_TYPE_DEFAULT_CREDIT);
        $paymentTypeTare = $this->config->getParameter(self::PAYMENT_TYPE_TARE, self::PAYMENT_TYPE_DEFAULT_TARE);
        $paymentTypeCard = $this->config->getParameter(self::PAYMENT_TYPE_CARD, self::PAYMENT_TYPE_DEFAULT_CARD);
        $paymentTypeCoupon = $this->config->getParameter(self::PAYMENT_TYPE_COUPON, self::PAYMENT_TYPE_DEFAULT_COUPON);

        $paymentArray = $params['payment'];
        $discountOnCheck = isset($params['discountOnCheck']) ? $params['discountOnCheck'] : 0;

        $Summ1 = isset($paymentArray['cash']) ? $paymentArray['cash'] : 0;
        $Summ2 = isset($paymentArray['credit']) ? $paymentArray['credit'] : 0;
        $Summ3 = isset($paymentArray['tare']) ? $paymentArray['tare'] : 0;
        $Summ4 = isset($paymentArray['card']) ? $paymentArray['card'] : 0;
        $Summ5 = isset($paymentArray['coupon']) ? $paymentArray['coupon'] : 0;
        $SummBonus = isset($paymentArray['bonus']) ? $paymentArray['bonus'] : 0;
        $SummMiscDiscount = isset($paymentArray['miscDiscount']) ? $paymentArray['miscDiscount'] : 0;
        $roundAmount = isset($paymentArray['roundAmount']) ? $paymentArray['roundAmount'] : 0;

        if (!is_numeric($Summ1) || !is_numeric($Summ2) || !is_numeric($Summ3) || !is_numeric($Summ4) || !is_numeric($SummBonus) || !is_numeric($SummMiscDiscount) || !is_numeric($discountOnCheck)) {
            $this->log(__METHOD__ . "   Ошибка. Переданная сумма неверного типа Summ1=$Summ1; Summ2=$Summ2; Summ3=$Summ3; Summ4=$Summ4; SummBonus=$SummBonus; SummMiscDiscount=$SummMiscDiscount; discount=$discountOnCheck \n", 1);
            return array('success' => false, 'error' => "Ошибка. Переданная сумма неверного типа\n",
                'errcode' => EC_API_ERROR,
                'Summ1' => $Summ1, 'Summ2' => $Summ2, 'Summ3' => $Summ3, 'Summ4' => $Summ4,
                'SummBonus' => $SummBonus, 'SummBonus' => $SummMiscDiscount, 'discount' => $discountOnCheck);
        }

        $totalDiscount = floatval($SummBonus) + floatval($SummMiscDiscount);

        if ($totalDiscount > 0) {
            if ($this->isLegacyMode) {
                $device->Destination = 0;
                $device->DiscountTypeNumber = 0;
                $device->summ = floatval($totalDiscount);
                $device->SummDiscount();
            }
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($discountOnCheck > 0) {
            if ($this->isLegacyMode) {
                $device->Percents = $discountOnCheck;
                $device->Destination = 0;
                $device->PercentsDiscount();
            }
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($roundAmount > 0) {
            $device->Destination = 0;
            $device->DiscountTypeNumber = 0;
            $device->summ = floatval($roundAmount);
            $device->SummDiscount();
        }

        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        $subTotal = $device->Summ;

        if ($Summ1 > 0) {
            $device->summ = floatval($Summ1);
            $device->TypeClose = $paymentTypeCash;
            $device->Payment();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($Summ2 > 0) {
            $device->summ = floatval($Summ2);
            $device->TypeClose = $paymentTypeCredit;
            $device->Payment();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($Summ3 > 0) {
            $device->summ = floatval($Summ3);
            $device->TypeClose = $paymentTypeTare;
            $device->Payment();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($Summ4 > 0) {
            $device->summ = floatval($Summ4);
            $device->TypeClose = $paymentTypeCard;
            $device->Payment();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($Summ5 > 0) {
            $device->summ = floatval($Summ5);
            $device->TypeClose = $paymentTypeCoupon;
            $device->Payment();
            if ($errResult = $this->_isDeviceFailed(__METHOD__))
                return $errResult;
        }

        if ($device->Remainder > 0) {
            $this->log(__METHOD__ . " ----- ERROR Покупка оплачена не польностью \n", 1);
            return array('success' => false, 'error' => 'Покупка оплачена не польностью', 'errcode' => EC_AMOUNT_CHECK_FAIL, 'hasStart' => true);
        }

        /*
          Здесь, лажа. Правильно устанавливать значение для _lastCheckNumber только !после! успешного CloseCheck.
          Но! Атол долго печатает подвал чека, и если в это время что-то отвалилось, то АТОЛ возвращает ошибку на CloseCheck,
          но при этом данные в своей памяти сохраняет, как-будто чек успешно закрылся.
         */

        //$this->_lastCheckNumber = $this->getCheckNumber($device); // Так было сделано для ЕГАИС
        $device->CloseCheck();
        $this->_lastGlobalCheckNumber = $device->DocNumber;
        $this->_lastCheckNumber = $this->getCheckNumber($device); // Но так делать правильнее

        $this->_lastCheckAmount = $device->Summ;

        // Если аппарат не фискализирован (старый или имеет ФН в режиме ЕНВД) то делаем + 1
        $device->RegisterNumber = 53;
        $device->GetRegister();
        $errResult = $this->_isDeviceFailed(__METHOD__, $device);
        $this->_sessionNumber = $errResult ? $device->Session + 1: $device->Session;

        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;


        $this->_change = $device->Change;
        $this->_waitWhilePrinting();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $device->RegisterNumber = 52;
        $device->GetRegister();
        $this->fiscalSign = $device->FiscalSign;

        $device->GetStatus();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $vatBunchAfterClose = $this->getVatBunch($device, $this->checkType);
        $moneyProfitAfterClose = $this->getMoneyProfit($device);

        $vatBunchDelta = $this->getVatBunchDelta($this->vatBunchBeforeCloseCheck, $vatBunchAfterClose);
        $this->vat10Sum = $vatBunchDelta['vat10'];
        $this->vat18Sum = $vatBunchDelta['vat18'];
        $this->vat20Sum = $vatBunchDelta['vat20'];

        $this->isMoneySumChanged = $this->moneyProfitBeforeCloseCheck !== $moneyProfitAfterClose;

        if ($this->_checkPaper()) {
            return array('success' => true);
        } else {
            $this->log(__METHOD__ . " ----- ERROR Закончилась бумага \n", 1);
            return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
        }
    }

    /**
     * Проводит операцию продажа, печатает ее на чеке
     *
     * @param array $params Массив параметров
     * @return array
     */
    protected function _do_sale($params) {
        $this->log(__METHOD__ . " - start\n", 3);

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
            if ($errResult['device_errnum'] != -12)
                return $errResult;
        }

        $vatPercent = isset($params['vat_percent']) ? $params['vat_percent'] : 0;
        $taxNumber = $this->_mapVatToTaxNumber($vatPercent);
        $printTaxNumberNo = $this->config->getParameter(self::PRINT_TAX_NUMBER_NO, self::PRINT_TAX_NUMBER_NO_DEFAULT);

        $itemParams = [
            'taxNumber' => $taxNumber,
            'price' => isset($params['priceWithFinalDiscount']) ? $params['priceWithFinalDiscount'] : $params['price'],
            'nameWIN1251' => iconv('utf-8', 'windows-1251', $params['item']),
            'nameUTF8' => $params['item'],
            'quantity' => $params['quantity'],
            'department' => isset($params['department']) ? $params['department'] : FP_DEFAULT_DEPARTMENT,
        ];
        $this->log(__METHOD__ . " - [{$itemParams['nameUTF8']}] [{$itemParams['price']}] [{$itemParams['quantity']}]\n", 3);
        if (isset($params['itemCodes'])) {
            $itemParams['itemCodes'] = $params['itemCodes'];
            $errResult = $this->addMarkedItem($device, $itemParams);
        } else {
            $errResult = $this->saleItem($device, $itemParams);
        }
        if ($errResult) {
            return $errResult;
        }

        if ($this->_isTaxNumberNo($taxNumber) && $printTaxNumberNo == 1) {
            $params['string'] = "без НДС";
            $params['alignment'] = 2; // выравниваем по правому краю, работает только в протоколе АТОЛ 2.x
            $this->_do_print($params);
        }
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        usleep(10000);

        if ($this->_checkPaper(true)) {
            $this->log(__METHOD__ . " - finish OK\n", 3);
            return array('success' => true);
        } else {
            $this->log(__METHOD__ . " - ERROR Закончилась бумага\n", 1);
            return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
        }
    }

    private function saleItem($device, $params)
    {
        $this->log(__METHOD__ . " - start\n", 3);

        $device->Destination = 1;
        $device->TaxTypeNumber = $params['taxNumber'];
        $device->SummTax();

        $device->Alignment = 0;
        $device->TextWrap = 1;

        $device->Name = $params['nameWIN1251'];
        $device->Quantity = $params['quantity'];
        $device->Price = $params['price'];
        $device->Department = $params['department'];

        $device->Registration();

        if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
            return $errResult;
        }

        return false;
    }

    private function returnItem($device, $params)
    {
        $this->log(__METHOD__ . " - start\n", 3);

        $device->Destination = 1;
        $device->TaxTypeNumber = $params['taxNumber'];
        $device->SummTax();

        $device->Alignment = 0;
        $device->TextWrap = 1;

        $device->Name = $params['nameWIN1251'];
        $device->Quantity = $params['quantity'];
        $device->Price = $params['price'];
        $device->Department = $params['department'];

        $device->Return();

        if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
            return $errResult;
        }

        return false;
    }

    private function addMarkedItem($device, $params)
    {
        $this->log(__METHOD__ . " - start\n", 3);

        $itemCodes = explode(',', $params['itemCodes']);
        $quantity = $params['quantity'];
//        if ((int)ceil($quantity) !== count($itemCodes)) {
//            $this->log(__METHOD__ . " - ERROR Количество кодов товара не соответствует количеству товара\n", 1);
//            return ['success' => false, 'error' => 'Количество кодов товара не соответствует количеству товара'];
//        }

        for ($i = 0; $quantity > 0.0; $quantity -= 1.0, $i++) {
            $itemCode = isset($itemCodes[$i]) ? $itemCodes[$i] : '';
            $this->log(__METHOD__ . " - [$itemCode]\n", 3);

            $device->BeginItem();

            if ($itemCode) {
                $device->StreamFormat = 5;
                $device->AttrNumber = 1162;
                $device->AttrValue = $itemCode;
                $device->WriteAttribute();
            }

            $device->Destination = 1;
            $device->TaxTypeNumber = $params['taxNumber'];
            $device->TaxMode = 0;
            $device->TaxSumm = 0; // ККТ посчитает автоматически

            $device->Alignment = 0;
            $device->TextWrap = 1;

            $device->Name = $params['nameWIN1251'];
            $unitQuantity = min($quantity, 1.0);
            $device->Quantity = $unitQuantity;
            $device->Price = $params['price'];
            $device->Department = $params['department'];
            $device->PaymentMode = 4;
            $device->ItemType = 1;
            $device->Summ = $params['price'] * $unitQuantity;

            $device->EndItem();

            if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
                return $errResult;
            }
        }

        return false;
    }

    /**
     * Проводит операцию возврат продажи
     *
     * @param array $params Массив параметров
     * @return array
     */
    protected function _do_returnsale($params) {
        $this->log(__METHOD__ . " - start\n", 3);

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $vatPercent = isset($params['vat_percent']) ? $params['vat_percent'] : 0;
        $taxNumber = $this->_mapVatToTaxNumber($vatPercent);

        $itemParams = [
            'taxNumber' => $taxNumber,
            'price' => isset($params['priceWithFinalDiscount']) ? $params['priceWithFinalDiscount'] : $params['price'],
            'nameWIN1251' => iconv('utf-8', 'windows-1251', $params['item']),
            'nameUTF8' => $params['item'],
            'quantity' => $params['quantity'],
            'department' => isset($params['department']) ? $params['department'] : FP_DEFAULT_DEPARTMENT,
        ];
        $this->log(__METHOD__ . " - [{$itemParams['nameUTF8']}] [{$itemParams['price']}] [{$itemParams['quantity']}]\n", 3);
        if (isset($params['itemCodes'])) {
            $itemParams['itemCodes'] = $params['itemCodes'];
            $errResult = $this->addMarkedItem($device, $itemParams);
        } else {
            $errResult = $this->returnItem($device, $itemParams);
        }
        if ($errResult) {
            return $errResult;
        }

        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;
        usleep(10000);

        if ($this->_checkPaper(true)) {
            $this->log(__METHOD__ . " - finish OK\n", 3);
            return array('success' => true);
        } else {
            $this->log(__METHOD__ . " - ERROR Закончилась бумага\n", 1);
            return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
        }
    }

    /**
     * Возвращает true если есть бумага
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _checkPaper($fast = false) {
        $this->log(__METHOD__ . " - start\n", 3);
        $device = $this->get_NativeDevice();

        $this->log(__METHOD__ . " Update Status \n", 3);

        // если быстрый запрос, то не выполняем дополнительного запроса к драйверу
        if (!$fast)
            $device->GetCurrentMode();

        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return false;

        $this->log(__METHOD__ . " Status updated\n", 3);

        /*
          $arr = array(
          'OutOfPaper' => $device->OutOfPaper,	// работает
          'CoverOpened' => $device->CoverOpened	// работает
          );

          var_dump($arr);
          die();
         */

        // если есть бумага и печатающая головка не перегрелась
        return !($device->OutOfPaper || $device->PrinterOverheatError);
    }

    /**
     * Инициализация ККМ
     */
    protected function _initialize() {
        parent::_initialize();

        $this->config = Config::getInstance();
        if (!isset($this->_nativeDevice)) {
            $this->_nativeDevice = new FRAtolFprintMNative();
        }
    }

    /**
     * Открытие порта
     * @param FRAtolFprintMNative $device_inpit объект драйвера
     * @return boolean true - порт удачно открыт
     * @throws Exception исключение в случае каких-то сбоев с открытием порта
     */
    protected function _internalOpen($device_inpit = NULL) {
        $this->log(__METHOD__ . " ----- start. Connecting to driver...\n", 3);
        $device = isset($device_inpit) ? $device_inpit : $this->get_NativeDevice();

        $this->log(__METHOD__ . " ----- start. Create logical device...\n", 3);
        if ($device->AddDevice() != 0) {
            $this->log(__METHOD__ . " ----- start. Create logical device...\n", 3);
            throw new Exception(__METHOD__ . " ----- start. Create logical device...\n");
        }

        $this->log(__METHOD__ . " Setup device COM Port...\n", 3);
        if ($this->_deviceCOMPortNumber < 0 && $this->_deviceIpAddress < 0) {
            $this->log(__METHOD__ . " ----- ERROR... want to specify a port (\$_GET['com']) \n", 1);
            throw new Exception("You have to specify COM or IP\n");
        }

        $this->log(__METHOD__ . " Detect COM Port. Setup device COM Port at {$this->_deviceCOMPortNumber} \n", 3);

        $baudDecode = array(
            1 => 110,
            2 => 300,
            3 => 600,
            4 => 1200,
            5 => 2400,
            6 => 4800,
            7 => 9600,
            8 => 14400,
            9 => 19200,
            10 => 38400,
            11 => 56000,
            12 => 57600,
            13 => 115200,
        );

        if ($this->_deviceIpAddress > 0) {
            $device->PortNumber = 99;
            $device->HostAddress = "$this->_deviceIpAddress:$this->_deviceTcpPort";
        } else {
            $device->PortNumber = 1000 + $this->_deviceCOMPortNumber;
        }
        if ($this->_deviceCOMPortBaud > 0) {
            $this->log(__METHOD__ . " ----- com port baud config detected. Setup baud \n", 3);

            if ($this->_deviceCOMPortBaud > 13) {
                $this->log(__METHOD__ . " ----- ERROR baudRate index too match. It must 1-13 \$_GET['com'] \n", 1);
                throw new Exception("ERROR baudRate index too match. It must 1-13 \n");
            }

            $device->BaudRate = $baudDecode[$this->_deviceCOMPortBaud];
            if ($this->_deviceModel != -1) {
                $device->Model = $this->_deviceModel;
            }
        }

        $this->log(__METHOD__ . " ----- enable device \n", 3);
        $this->log(__METHOD__ . " Using COM-port: {$device->PortNumber}:{$device->BaudRate} (settings: {$this->_deviceCOMPortNumber}:{$this->_deviceCOMPortBaud} model:{$this->_deviceModel})...\n", 3);
        $device->DeviceEnabled = true;

        $this->log(__METHOD__ . " ----- check enable DeviceEnable and ResultCode \n", 3);
        if ($device->DeviceEnabled === false) {
            $errstr = FpUtils::convertToString($device->ResultCode);
            $this->log(__METHOD__ . " ----- ERROR COM Port not open. ResultCode: {$errstr} \n", 1);
            throw new Exception("COM Port not open. ResultCode: {$errstr} \n");
        }

        $this->log(__METHOD__ . " ----- setup default mode password \n", 3);
        if (isset($this->_nativeDevice)) {
            $this->_nativeDevice->Password = FP_PASSWORD_SYSADMIN;
        }

        $this->log(__METHOD__ . " ----- Connected OK\n", 3);

        return true;
    }

    /**
     * Закрытие порта
     * @param FRAtolFprintMNative $device_inpit объект драйвера
     * @return boolean true - порт удачно закрыт
     */
    protected function _internalClose($device_inpit = NULL) {
        $this->log(__METHOD__ . " ----- start\n", 3);

        $device = isset($device_inpit) ? $device_inpit : $this->get_NativeDevice();

        $this->log(__METHOD__ . " Disconnecting from device...\n", 3);
        $device->DeviceEnabled = false;

        if ($device->ResultCode != 0)
            return false;

        $this->_connected = false;
        $this->log(__METHOD__ . " Disonnected OK\n", 3);

        return true;
    }

    /**
     * Получить номер последней ошибки
     * @param FRAtolFprintMNative $dev
     * @return int
     */
    protected function _internalGetLastError($dev = NULL) {
        $device = isset($dev) ? $dev : $this->get_NativeDevice();
        return $device->ResultCode;
    }

    /**
     * Описание последней ошибки
     * @param FRAtolFprintMNative $dev
     * @return string конвертированная в utf-8 строка ошибки
     */
    protected function _internalGetLastErrorMessage($dev = NULL) {
        $device = isset($dev) ? $dev : $this->get_NativeDevice();
        return FpUtils::convertToString($device->ResultDescription);
    }

    /**
     * Инициализация конфига
     */
    public function InitConfig($params) {
        $this->log(__METHOD__ . " ----- start init config\n", 3);

        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // переводим в режим программирования
        $device->Mode = 4;
        $device->Password = FP_PASSWORD_SYSADMIN;
        $device->SetMode();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        /*
          FieldType
          ТипПоля
          Int RW
          Тип поля:
           0 – целое число;
           1 – строка символов;
           2 – массив данных
         */

        // производим настройку времени ФР
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        $time = strtotime($params['dateTime']);
        $device->Hour = date('H', $time);
        $device->Minute = date('i', $time);
        $device->Second = date('s', $time);
//		$device->SetTime();	// устанавливаем, не проверяем. Если находимся в правильном режиме сменем или время не сменится
        // устанавливаем не печатать клише и рекламы
        $device->Table = 2;
        $device->Row = 1;
        $device->Field = 24;
        $device->FieldType = 0;
        $device->Caption = 0;
        $device->SetSettings();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;


        //Количество печатаемых строк после чека на ЧЛ1
        $device->Table = 2;
        $device->Row = 1;
        $device->Field = 36;
        $device->FieldType = 0;
        $device->Caption = 0; // нет строк заголовка, все формируем вручную
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;


        //Печатать документ открытия смены
        $device->Table = 2;
        $device->Row = 1;
        $device->Field = 43;
        $device->FieldType = 0;
        $device->Caption = 0; // нет строк заголовка, все формируем вручную
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        // Количество строк заголовка клише
        $device->Table = 2;
        $device->Row = 1;
        $device->Field = 94;
        $device->FieldType = 0;
        $device->Caption = 0; // нет строк заголовка, все формируем вручную
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;


        // включим звуковую индикацию при возникновении ошибок
        $device->Table = 2;
        $device->Row = 1;
        $device->Field = 97;
        $device->FieldType = 0;
        $device->Caption = 3;
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
            return $errResult;

        /*
          $device->ValuePurpose = 45;
          $device->Value = 0;
          $device->SetValue();
          if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
          return $errResult;

          $device->ValuePurpose = 46;
          $device->Value = 0;
          $device->SetValue();
          if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
          return $errResult;
         */

        $this->log(__METHOD__ . " Disonnected OK\n", 3);

        return array('success' => true, 'info' => 'configure complete');
    }

    /**
     * Обрезка чека
     *
     * @param array $params Массив параметров. Необязательный параметр $params[timeout] - время в миллисекундах, сколько ждать принтер чеков
     * @return bool
     */
    protected function _do_cut($params = array()) {
        $this->log(__METHOD__ . " ----- start with params: [" . json_encode($params, JSON_UNESCAPED_UNICODE) . "]\n", 3);
        $device = $this->get_NativeDevice();

        // если параметр не передан, то по умолчанию полная отрезка
        $params['fullcut'] = !isset($params['fullcut']) ? false : $params['fullcut'];

        try {
            if ($params['fullcut'])
                $device->FullCut();
            else
                $device->PartialCut();
        } catch (Exception $e) {
            //Skip cut errors
            $this->log(__METHOD__ . " Cut method not supported (or just error occured) " . $e->getMessage() . " \n", 2);
            return array('success' => true);
        }

        //if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

        return array('success' => true);
    }

    /**
     * Прогон чека на несколько строк вперед
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_feed($params) {
        $this->log(__METHOD__ . " - start\n", 3);
        $device = $this->get_NativeDevice();
        if ($errResult = $this->_isDeviceFailed(__METHOD__))
            return $errResult;

        $quantity = $params['linesQuantity'];

        for ($i = 0; $i < $quantity; ++$i) {
            $this->_do_print(array('string' => ' '));
        }

        $this->_waitWhilePrinting();

        if ($this->_checkPaper()) {
            return array('success' => true);
        } else {
            $this->log(__METHOD__ . " ----- ERROR Закончилась бумага \n", 1);
            return array('success' => false, 'error' => 'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
        }
    }

    /**
     * Открыть денежный ящик
     * @param type $params
     */
    protected function _do_openDrawer($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);
        $device = $this->get_NativeDevice();
        //if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
        //$device->OpenDrawer();
        $this->log(__METHOD__ . " ----- end. OK\n", 3);
        return array('success' => true);
    }

    /**
     * Печать штрихкода ean13
     *
     * @param array $params Массив параметров
     * @return bool
     */
    protected function _do_printbarcode($params) {
        $this->log(__METHOD__ . " ----- start\n", 3);
        $device = $this->get_NativeDevice();

        $types = array(
            "UPC-A" => "0", "CODE39" => "1", "EAN13" => "2", "EAN8" => "3", "UPC-E" => "4", "ITF" => "5", "CODEBAR" => "6",
            "CODE93" => "7", "CODE128" => "8", "PDF417" => "10", "CODE32" => "20", "EAN128 CC-A/B" => "82", "EAN128 CC-C" => "83", "QR" => "84",
        );

        $barcodeValue = iconv('utf-8', 'windows-1251', $params['barcode']);
        $scale = isset($params['scale']) ? $params['scale'] : 100;

        $barcodeType = isset($params['type']) ? $params['type'] : "EAN13";
        if (!array_key_exists($barcodeType, $types)) {
            $this->log(__METHOD__ . " ----- ERROR Тип штрих-кода не поддерживается $barcodeType \n", 1);
            return array('success' => false, 'error' => 'Тип штрих-кода не поддерживается', 'errcode' => EC_API_ERROR);
        }
        if ($barcodeType === "QR" && !isset($params['scale'])) $scale = 600;

        $barcodeInternalType = $types[$barcodeType];

        $device->Barcode = $barcodeValue; // ШтрихКод Str RW Символьный эквивалент штрихкода
        $device->BarcodeType = $barcodeInternalType; //ТипШтрихКода Int RW Тип штрихкода:  0 – UPC-A;  1 – CODE39;  2 – (E/J)AN13;  3 – (E/J)AN8;  4 – UPC-E;  5 –ITF;  6 – CODEBAR;  7 –CODE93;  8 – CODE128;  10 – PDF 417;  20 – CODE32;  82 – EAN 128 CC-A/B;  83 – EAN 128 CC-C
        $device->Alignment = 1; //Выравнивание Int RW Выравнивание:   0 – по левому краю;  1 – по центру;  2 – по правому краю
        $device->Scale = $scale; //Масштаб Dbl RW Масштаб изображения
        $device->PrintBarcodeText = 2; //ПечататьТекстШтрихКода Int RW Печатать символьный эквивалент штрихкода: [Интерфейс драйвера]  199 Название Тип Дост. Значения  0 – не печатать;  1 – печатать над ШК;  2 – печатать под ШК;  3 – печатать над/под ШК
        if ($barcodeInternalType === "84") $device->BarcodeOptions = 16777217;// попытка использовать буквенно-цифровой режим и кодировку UTF-8. 31 бит использован чтобы не конфликтовать со знаковым битом

        $device->PrintBarcode();
        $this->_waitWhilePrinting();

        if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
            $this->log(__METHOD__ . " ----- ERROR " . print_r($errResult, true) . " \n", 1);
            return $errResult;
        }

        $this->log(__METHOD__ . " ----- end. OK\n", 3);
        return array('success' => true);
    }

    private function setOperatorName($name) {
        if (isset($name) && !empty($name)) {
            $device = $this->get_NativeDevice();
            $device->Mode = 4;
            $device->Password = FP_PASSWORD_SYSADMIN;
            $device->SetMode();
            $device->CaptionPurpose = $this->operatorCaptionPurpose;
            $device->Caption = iconv('utf-8', 'windows-1251', $name);
            $device->SetCaption();
        }
    }

    private function createSession24BlockResponse() {
        return array(
            'success' => false,
            'error' => 'Текущая смена длится более 24 часов. Для продолжения работы выполните процедуру закрытия смены',
            'errcode' => EC_SESSION_24HOURS_BLOCK,
            'ecrmode' => $device->Mode,
            'ecradvmode' => $device->AdvancedMode
        );
    }

    private function printOrganizationBatch($params) {
        if (isset($params['organizationName']) && strlen($params['organizationName']) > 0) {
            $paramsOrganizationName = array("string" => $params['organizationName']);
            $this->_do_print($paramsOrganizationName);
        }

        if (isset($params['organizationAddress'])) {
            foreach ($params['organizationAddress'] as $value) {
                $paramsOrganizationAddress = array("string" => $value);
                $this->_do_print($paramsOrganizationAddress);
            }
        }

        if (isset($params['operatorName']) && strlen($params['operatorName']) > 0) {
            $paramsOperatorName = array("string" => $params['operatorName']);
            $this->_do_print($paramsOperatorName);
        }
    }

    private function getVatBunch($device, $checkType = 1) {
        $number10 = $this->config->getParameter(self::VAT_NAME_10, self::VAT_NAME_DEFAULT_10);
        $number18 = $this->config->getParameter(self::VAT_NAME_18, self::VAT_NAME_DEFAULT_18);
        $number20 = $this->config->getParameter(self::VAT_NAME_20, self::VAT_NAME_DEFAULT_20);

        $device->RegisterNumber = 31;
        $device->CheckType = $checkType;
        $device->TaxTypeNumber = $number10;
        $device->GetRegister();
        $result['vat10'] = $device->Summ;

        $device->RegisterNumber = 31;
        $device->CheckType = $checkType;
        $device->TaxTypeNumber = $number18;
        $device->GetRegister();
        $result['vat18'] = $device->Summ;

        $device->RegisterNumber = 31;
        $device->CheckType = $checkType;
        $device->TaxTypeNumber = $number20;
        $device->GetRegister();
        $result['vat20'] = $device->Summ;

        return $result;
    }

    private function getVatBunchDelta($batchBefore, $batchAfter) {
        $result['vat10'] = $batchAfter['vat10'] - $batchBefore['vat10'];
        $result['vat18'] = $batchAfter['vat18'] - $batchBefore['vat18'];
        $result['vat20'] = $batchAfter['vat20'] - $batchBefore['vat20'];
        return $result;
    }

    private function getMoneyProfit($device) {
        $device->RegisterNumber = 11;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $this->log(__METHOD__ . "Register 11\n", 1);
            return 0;
        } else {
            return $device->Summ;
        }
    }

    private function getCheckNumber($device) {
        $device->RegisterNumber = 53;
        $device->GetRegister();
        if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
            $device->RegisterNumber = 19;
            $device->GetRegister();
            return $device->CheckNumber;
        } else {
            return $device->Count;
        }
    }

    private function getInn($device = NULL) {
        if (is_null($device)) {
            $device = $this->get_NativeDevice();
        }
        $device->RegisterNumber = 27;
        $device->GetRegister();
        $result = $device->INN;
        if ((int) $result === 0) {
            $device->AttrNumber = 1018;
            $device->ReadAttribute();
            $resultFromAttribute = $device->AttrValue;
            if (!empty($resultFromAttribute)) {
                $result = $resultFromAttribute;
            }
        }
        return trim($result);
    }

    private function isSessionOpened($device = NULL) {
        if (is_null($device)) {
            $device = $this->get_NativeDevice();
        }
        $device->RegisterNumber = 18;
        $device->GetRegister();
        return $device->SessionOpened;
    }

    private function legacyConvertCheckPrint($lines) {
        $discountCount = 0; // количество команд discount
        $discountSumm = 0.0; // сумма скидок всех команд discount
        $closeCheckCommandKey; // ключ с командой закрытия чека

        foreach ($lines as $key => $line) {// подсчет количества и суммы всех скидок
            $action = $line['action'];
            if ($action === "discount") {
                $discountCount++;
                $discountSumm += $line['params']['amount'];
            } else if ($action === "closecheck") {
                $closeCheckCommandKey = $key;
            }
        }

        if ($discountCount > 0) {
            $newLines = array_map(function($line) { // преобразуем команды discount в команды print, чтобы не потерять визуальную составляющую скидок на позиции
                $action = $line['action'];
                if ($action === "discount") {
                    $newLine['action'] = "print";
                    $description = $line['params']['description'];

                    if (!empty($description) && $description !== ' ') {
                        $newLine['params']['string'] = "$description " . $line['params']['amount'];
                    } else {
                        $newLine['params']['string'] = "СКИДКА " . $line['params']['amount'];
                    }
                    $newLine['params']['alignment'] = 2; // выравниваем по правому краю, работает только в протоколе АТОЛ 2.x
                    return $newLine;
                } else {
                    return $line;
                }
            }, $lines);

            $miscDiscount = floatval($newLines[$closeCheckCommandKey]['params']['payment']['miscDiscount']);
            $miscDiscount += $discountSumm;
            $newLines[$closeCheckCommandKey]['params']['payment']['miscDiscount'] = $miscDiscount;
            return $newLines;
        } else {
            return $lines;
        }
    }

    private function finalDiscountConvertCheckPrint($lines) {
        $newLines = array();
        foreach ($lines as $line) {
            $action = $line['action'];
            if ($action === "discount") {
                $newLine['action'] = "print";
                $description = $line['params']['description'];
                $finalDiscountAmount = number_format($line['params']['amount'], 2);
                if (!empty($description) && $description !== ' ') {
                    $newLine['params']['string'] = "$description" . ": " . $finalDiscountAmount;
                } else {
                    $newLine['params']['string'] = "СКИДКА: " . $finalDiscountAmount;
                }
                $newLine['params']['alignment'] = 2; // выравниваем по правому краю, работает только в протоколе АТОЛ 2.x
                $newLines[] = $newLine;
            } else {
                $newLines[] = $line;
            }
        }
        return $newLines;
    }

}
