<?php

require 'core/FiscalPrinter.php';
require 'fp_shtrihm_native.php';


DEFINE ('FP_DEFAULT_PASSWORD',  '30');
DEFINE ('FP_DEFAULT_DEPARTMENT', '0');
DEFINE ('FP_DEFAULT_CHECK_TYPE', '0');

//ecrMode
DEFINE ('FR_ECRMode_READY_FOR_PRINT', '0');   //Принтер в рабочем режиме
DEFINE ('FR_ECRMode_PRINTING', '1');   //Выдача данных
DEFINE ('FR_ECRMode_SESSION_IS_OPEN', '2');   //Открытая смена, 24 часа не кончились
DEFINE ('FR_ECRMode_24HOUR_BLOCK', '3');      //Открытая смена, 24 часа кончились
DEFINE ('FR_ECRMode_SESSION_IS_CLOSED', '4'); //Закрытая смена
DEFINE ('FR_ECRMode_WRONG_PASSWORD_BLOCK', '5');   //Блокировка по неправильному паролю налогового инспектора
DEFINE ('FR_ECRMode_CONFIRM_DATE_WAIT', '6');   //Ожидание подтверждения ввода даты
DEFINE ('FR_ECRMode_DEC_POINT_CHANGE_ALLOWED', '7');   //Разрешение изменения положения десятичной точки
DEFINE ('FR_ECRMode_OPENED_DOCUMENT', '8');  //Открытый документ
DEFINE ('FR_ECRMode_TECH_NULL_MODE', '9');   //Режим разрешения технологического обнуления
DEFINE ('FR_ECRMode_TEST_PRINT', '10');   //Тестовый прогон
DEFINE ('FR_ECRMode_FISCAL_REP_PRINTING', '11');   //Печать полного фискального отчета
DEFINE ('FR_ECRMode_EKLZ_PRINTING', '12');   //Печать длинного отчета ЭКЛЗ
DEFINE ('FR_ECRMode_PODKLAD_DOC_WORKING', '13');   //Работа с фискальным подкладным документом
DEFINE ('FR_ECRMode_PODKLAD_DOC_PRINTING', '14');   //Печать подкладного документа
DEFINE ('FR_ECRMode_PODKLAD_DOC_READY', '15');   //Фискальный подкладной документ сформирован

//ECRAdvancedMode
DEFINE ('FR_ECRAdvMode_OK', '0');  //  Бумага есть– ФР не в фазе печати операции– может принимать от хоста команды, связанные с печатью на том ленте, датчик которой сообщает о наличии бумаги.
DEFINE ('FR_ECRAdvMode_NOPAPER', '1');  //  Пассивное отсутствие бумаги– ККМ не в фазе печати операции– не принимает от хоста команды, связанные с печатью на том ленте, датчик которой сообщает об отсутствии бумаги.
DEFINE ('FR_ECRAdvMode_NOPAPER_BLOCK', '2');  //  Активное отсутствие бумаги– ККМ в фазе печати операции– принимает только команды, не связанные с печатью. Переход из этого подрежима только в подрежим 3.
DEFINE ('FR_ECRAdvMode_WAIT_FOR_RESUME', '3');  //  После активного отсутствия бумаги–ККМ ждет команду продолжения. Кроме этого принимает команды, не связанные с печатью.
DEFINE ('FR_ECRAdvMode_PRINTING', '4');  //  Фаза печати операции– ККМ не принимает от хоста команды, связанные с печатью.
DEFINE ('FR_ECRAdvMode_REPORT_PRINTING', '5');  //  Фаза печати операции длинного отчета(полные фискальные отчеты, полные отчеты ЭКЛЗ, печать контрольных лент из ЭКЛЗ) – ККМ не принимает от хоста команды, связанные с печатью, кроме команды прерывания печати.

/* The goal of this class is translate standard interface methods to native driver calls */

class fiscalprinter_shtrihm extends FiscalPrinter {

	// Тип регистра
	const REGTYPE_CASH = 1;
	const REGTYPE_OPERATION = 2;

	// Названия регистров которые требуется получать
	// === ЧЕКОВ ПРОДАЖ ===
	const REG_OPER_SALE_COUNTS = 144; // Количество чеков продаж в смене
	const REG_OPER_SALE_COUNTS_DISCOUNT = 136; // количество  скидок  с типом продажа
	const REG_CASH_SALE_SUM = 121;
	const REG_CASH_SALE_SUM_DISCOUNT = 185; //Накопление скидок с продаж в смене
	const REG_CASH_SALE_SUM_CASH = 193;
	const REG_CASH_SALE_SUM_CREDIT = 197;
	const REG_CASH_SALE_SUM_TARE = 201;
	const REG_CASH_SALE_SUM_CARD = 205;
	const REG_CASH_TOTAL_SALE_SUM = 244;//необнуляемая сумма до фискализации

	// === Чеков покупок ===
	const REG_OPER_BUY_COUNTS = 145; // Количество чеков покупок в смене
	const REG_CASH_BUY_SUM = 122;
	const REG_CASH_BUY_SUM_CASH = 194;
	const REG_CASH_BUY_SUM_CREDIT = 198;
	const REG_CASH_BUY_SUM_TARE = 202;
	const REG_CASH_BUY_SUM_CARD = 206;

	// === Чеков возвратов продаж ===
	const REG_OPER_SALERET_COUNTS = 146; // Количество чеков возврата продаж в смене
	const REG_CASH_SALERET_SUM = 123;
	const REG_CASH_SALERET_SUM_CASH = 195;
	const REG_CASH_SALERET_SUM_CREDIT = 199;
	const REG_CASH_SALERET_SUM_TARE = 203;
	const REG_CASH_SALERET_SUM_CARD = 207;

	// === Чеков возврата покупок ===
	const REG_OPER_BUYRET_COUNTS = 147; // Количество чеков возврата покупок в смене
	const REG_CASH_BUYRET_SUM = 124;
	const REG_CASH_BUYRET_SUM_CASH = 196;
	const REG_CASH_BUYRET_SUM_CREDIT = 200;
	const REG_CASH_BUYRET_SUM_TARE = 204;
	const REG_CASH_BUYRET_SUM_CARD = 208;

	// === Внесений ===
	const REG_OPER_MONEYINPUT_COUNT_GLOBAL = 155;
	const REG_OPER_MONEYINPUT_COUNT = 153;
	const REG_CASH_MONEYINPUT_SUM = 242;

	// === Выплат ===
	const REG_OPER_MONEYOUTPUT_COUNT_GLOBAL = 156;
	const REG_OPER_MONEYOUTPUT_COUNT = 154;
	const REG_CASH_MONEYOUTPUT_SUM = 243;

	// ===Аннулированных чеков===
	const REG_OPER_ANNULATE_COUNT_GLOBAL = 166;
	// за смену
	const REG_OPER_ANNULATE_SALE_COUNT = 179;	// продаж
	const REG_CASH_ANNULATE_SALE_SUM = 249; // Сумма аннулированных продаж в смене
	const REG_OPER_ANNULATE_BUY_COUNT = 180;	// покупок
	const REG_CASH_ANNULATE_BUY_SUM = 250; // Сумма аннулированных покупок в смене
	const REG_OPER_ANNULATE_SALERET_COUNT = 181;// возвр. пролаж
	const REG_CASH_ANNULATE_SALERET_SUM = 251; // Сумма аннулированных возвратов продаж в смене
	const REG_OPER_ANNULATE_BUYRET_COUNT = 182;	// возвр. покупок
	const REG_CASH_ANNULATE_BUYRET_SUM = 252; // Сумма аннулированных возвратов покупок в смене

	// ===Инкассация===
	const REG_CASH_ALLCASH_SUM = 241;			// накопление наличности в кассе

	// ===Выручка===
	//const REG_CASH_SALE_SUM = 121;			// Накопление продаж в 1 отдел в смене

	// регистр: Номер сменного отчета без гашения : 897,00
	const REG_OPER_XREPORT_NUMBER = 158;

        /**
         * Используется для совместимости со старыми версиями VirtualPos и старыми чеками при возвратах в новом VirtualPos
         * @var type
         */
        private $isLegacyMode = false;

        public static function convEncode($str)
	{
		return iconv('windows-1251', 'utf-8', $str);
	}

	public static function convDate($date)
	{
		return date('d.m.Y', time($date));
	}

	public static function convTime($date)
	{
		return time($date);
	}

	public function getStringSize()
	{
		return 36;
	}

	// перечисление всех регистров
	//const CASHREG_

	protected function _initialize() {
		parent::_initialize();
		if (!isset($this->_nativeDevice)) {
			$this->_nativeDevice = new FRShtrihMNative();
			if (isset($device)) $device->Password = FP_DEFAULT_PASSWORD;
		}
	}

        protected function _internalOpen($dev = NULL) {
            $this->log(__METHOD__ . " ----- start\n", 3);
            $device = isset($dev) ? $dev : $this->get_NativeDevice();
            $this->log(__METHOD__ . " Connecting to device...\n", 3);

            if ($this->_deviceIpAddress != -1) {
                $device->ComputerName = $this->_deviceIpAddress;
                $device->TcpPort = $this->_deviceTcpPort;
                $device->ConnectionType = 6;
            } else {
                if ($this->_deviceCOMPortNumber != -1)
                    $device->ComNumber = $this->_deviceCOMPortNumber;
                if ($this->_deviceCOMPortBaud != -1) {
                    $baudDecode = array('5' => '0', '6' => '1', '7' => '2', '9' => '3', '10' => '4', '12' => '5', '13' => '6');
                    $device->BaudRate = $baudDecode[$this->_deviceCOMPortBaud];
                }
                $this->log(__METHOD__ . " Using COM-port: {$device->ComNumber}:{$device->BaudRate} (settings: {$this->_deviceCOMPortNumber}:{$this->_deviceCOMPortBaud})...\n", 3);
            }
            $device->Connect();
            if ($device->ResultCode != 0) {
                $this->log(__METHOD__ . " ----- ERROR connecting \n", 3);
                return false;
            }
            $this->_connected = true;
            $this->log(__METHOD__ . " ----- Connected OK\n", 3);
            return true;
        }

        protected function _internalClose($dev = NULL) {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = isset($dev) ? $dev : $this->get_NativeDevice();
		$this->log(__METHOD__ . " Disconnecting from device...\n", 3);
		$device->Disconnect();
		if ($device->ResultCode != 0) return false;
		$this->_connected = false;
		$this->log(__METHOD__ . " Disonnected OK\n", 3);
		return true;
	}

	protected function _internalGetLastError($dev = NULL) {
		$device = isset($dev) ? $dev : $this->get_NativeDevice();
		return $device->ResultCode;
	}

	protected function _internalGetLastErrorMessage($dev = NULL) {
		$device = isset($dev) ? $dev : $this->get_NativeDevice();
		return iconv('windows-1251', 'utf-8', $device->ResultCodeDescription);
	}

	/***
	 * Возвращает серийный номер фискального регистратора
	 *
	 * @param
	 * @return
	 */
	protected function _internalGetSerialNumber($dev = NULL){
		$device = isset($dev) ? $dev : $this->get_NativeDevice();
		$device->GetECRStatus();
		return ($this->_internalGetLastError($device) == 0) ? $device->SerialNumberAsInteger : NULL;
	}

	/**
	 * Возвращает дату и время фискального регистратора
	 *
	 * @param
	 * @return
	 */
	protected function _internalGetDateTime($dev = NULL){
		$ecrStatus  = $this->GetAllECRStatus();
		return $ecrStatus['data']['Date']." ".$ecrStatus['data']['TimeStr'];
	}

	protected function _getOperationReg($num) {
		$device = $this->get_NativeDevice();

		$device->RegisterNumber = $num;
		$device->GetOperationReg();
		return $device->ContentsOfOperationRegister;
	}

	protected function _getCashReg($num) {
		$device = $this->get_NativeDevice();

		$device->RegisterNumber = $num;
		$device->GetCashReg();
		return $device->ContentsOfCashRegister;
	}

	protected function _internalGetLastSessionNumber() {
		$device = $this->get_NativeDevice();
		$device->GetECRStatus();
		return ($this->_internalGetLastError() == 0) ? $device->SessionNumber : NULL;
	}






	/*OVERRIDE DEVICE METHODS*/

	/**
	 * Устанавливает соединение с устройством для дальнейшей работы (открывает COM порт)
	 *
	 * @param
	 * @return bool
	 */
	public function Open() {
		parent::Open();
		$result = $this->_internalOpen();
		if (!$result) return $this->_isDeviceFailed(__METHOD__);
		return array('success' => true);
	}

	/**
	 * Закрывает соединение с устройством (закрывает COM порт)
	 *
	 * @param
	 * @return bool
	 */
	public function Close() {
		parent::Close();
		$result = $this->_internalClose();
		if (!$result) return $this->_isDeviceFailed(__METHOD__);
		return array('success' => true);
	}

	/**
	 * Возвращает ИСТИНА если соединение с устройством установлено
	 *
	 * @param
	 * @return bool
	 */
	public function IsOpen() {
		$result = $this->_internalIsOpen();
		return array('success' => true, 'isopen' => $result);
	}

	/**
	* Устанавливает скорость подключения к ком-порту, на котором сидит устройство
	//Скорости: 1-110, 2-300,3-600,4-1200,5-2400,6-4800,7-9600,8-14400,9-19200,10-38400,11-56000,12-57600,13-115200
	*/
	public function SetComPortBaud($baud) {
		if ( !is_numeric($baud) || ($baud == -1) || ($baud < 5) || ($baud > 13) || ($baud == 8) || ($baud == 11)){
			$this->log(__METHOD__ . " COMport BaudRate=$baud does not supported\n", 1);
			return array('success'=>false, 'error' => "Скорость COM-порта [$baud] не поддерживается");
		}

		$this->_deviceCOMPortBaud = $baud;
	}

	/*OVERRIDE FISCAL PRINTER METHODS */


	/**
	 * Печатает строку на чеке
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_print($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$str = $params['string'];
                $str = preg_replace('/\x01/', '', $str);

                $useJournalRibbon = true;
		if(isset($params['useJournalRibbon']))
			$useJournalRibbon = $params['useJournalRibbon'] === true;

		if (is_string($str)) {
			$device = $this->get_NativeDevice();
			/*
			Метод может вызываться в любом режиме, кроме режимов 11, 12 и 14 (см. свойство ECRMode).
			*/
			if (!$this->_waitEscapeFromMode(array(FR_ECRMode_FISCAL_REP_PRINTING, FR_ECRMode_EKLZ_PRINTING, FR_ECRMode_PODKLAD_DOC_PRINTING), array(), 4000)) {
				if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
				$this->log(__METHOD__ . " ----- end. ERROR . Текущий режим [ECRMode={$device->ECRMode}] не позволяет напечатать строку [$str]\n", 1);
				return array('success'=>false, 'error'=>"Текущий режим устройства [ECRMode={$device->ECRMode}] не позволяет печатать");
			}
			$device->UseJournalRibbon = $useJournalRibbon;
			$device->StringForPrinting = $this->alignString(substr(iconv('utf-8', 'windows-1251', $str), 0, $this->getStringSize()));
			$device->PrintString();
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$device->StringForPrinting = '';
			$this->_waitWhilePrinting();
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

			if ($this->_checkPaper()){
				return array('success'=>true);
			} else {
				return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
			}

		} else {
			return array('success'=>false, 'error'=>'Неверный тип параметра для печати. Должен быть string');
		}
	}

	/**
	 * Печатает строку на чеке с возможностью подстановки параметров
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_printex($params){

		while (strpos($params['string'], '@')) {
			if (strpos($params['string'], '@TOTAL_OPERATIONS')) {
				$device = $this->get_NativeDevice();
				$device->GetShortECRStatus();
				$qty = $device->QuantityOfOperations;
				$params['string'] = str_replace('@TOTAL_OPERATIONS', $qty, $params['string']);
			}
			elseif (strpos($params['string'], '@POS_NUMBER')) { //Номер кассы в отделе
				$device = $this->get_NativeDevice();
				$device->GetECRStatus();
				$value = $device->LogicalNumber;
				$params['string'] = str_replace('@POS_NUMBER', $value, $params['string']);
			}
			elseif (strpos($params['string'], '@CURRENT_CHECK_NUMBER')) { //Номер текущего чека
				switch($device->CheckType){
					case 0:
						$checkRegister = self::REG_OPER_SALE_COUNTS;
						break;
					case 1:
						$checkRegister = self::REG_OPER_BUY_COUNTS;
						break;
					case 2:
						$checkRegister = self::REG_OPER_SALERET_COUNTS;
						break;
					case 3:
						$checkRegister = self::REG_OPER_BUYRET_COUNTS;
						break;
					default:
						$checkRegister = self::REG_OPER_SALE_COUNTS;
						break;
				}
				$value = $this->_getOperationReg($checkRegister);
				$value += 1;
				$params['string'] = str_replace('@CURRENT_CHECK_NUMBER', $value, $params['string']);
			}
			/*
			elseif (strpos($params['string'], '@MY_OPERATION')) {
				$value = 'my value';
				$params['string'] = str_replace('@MY_OPERATION', $value, $params['string']);
			}*/
		}
		return $this->_do_print($params);
	}


	/**
	 * Открывает чек для добавления позиций
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_opencheck($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();

		$this->setOperatorName($params['operatorName']);

		$password = isset($params['password']) ? $params['password'] : FP_DEFAULT_PASSWORD;
		$checkType = isset($params['checktype']) ? $params['checktype'] : FP_DEFAULT_CHECK_TYPE; //«0» - продажа, «1» - покупка, «2» - возврат продажи, «3» - возврат покупки
		$device->CheckType = $checkType;

		$device->OpenCheck();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if (isset($params['mdlpReceiptAttr'])) {
			$device->TagNumber = 1084;
			$device->FNBeginSTLVTag();

			if (isset($params['mdlpReceiptAttr']['name'])) {
				$device->TagNumber = 1085;
				$device->TagType = 7;
				$device->TagValueStr = iconv('UTF-8', 'CP866', $params['mdlpReceiptAttr']['name']);
				$device->FNAddTag();
			}

			if (isset($params['mdlpReceiptAttr']['value'])) {
				$device->TagNumber = 1086;
				$device->TagType = 7;
				$device->TagValueStr = iconv('UTF-8', 'CP866', $params['mdlpReceiptAttr']['value']);
				$device->FNAddTag();
			}

			$device->FNSendSTLVTag();
		}

		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			return array('success'=>true);
		} else {
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}
	}


	/**
	 * Закрывает чек
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_closecheck($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();

		$paymentArray = $params['payment'];
		$discountOnCheck = isset($params['discountOnCheck']) ? $params['discountOnCheck'] : 0;

		$Summ1 = isset($paymentArray['cash']) ? $paymentArray['cash'] : 0;
		$Summ2 = isset($paymentArray['credit']) ? $paymentArray['credit'] : 0;
		$Summ3 = isset($paymentArray['tare']) ? $paymentArray['tare'] : 0;
		$Summ4 = isset($paymentArray['card']) ? $paymentArray['card'] : 0;
		$SummBonus = isset($paymentArray['bonus']) ? $paymentArray['bonus'] : 0;
		$SummMiscDiscount = isset($paymentArray['miscDiscount']) ? $paymentArray['miscDiscount'] : 0;
                $roundAmount = isset($paymentArray['roundAmount']) ? $paymentArray['roundAmount'] : 0;

                if (!is_numeric($Summ1) || !is_numeric($Summ2) || !is_numeric($Summ3) || !is_numeric($Summ4) ||  !is_numeric($SummBonus) || !is_numeric($discountOnCheck)) {
			$this->log(__METHOD__ . "   Ошибка. Переданная сумма неверного типа Summ1=$Summ1; Summ2=$Summ2; Summ3=$Summ3; Summ4=$Summ4; SummBonus=$SummBonus; discount=$discountOnCheck \n", 1);
			return array('success' => false, 'error' => "Ошибка. Переданная сумма неверного типа\n",
						'errcode' => EC_API_ERROR,
						'Summ1' => $Summ1,'Summ2' => $Summ2,'Summ3' => $Summ3,'Summ4' => $Summ4, 'SummBonus' => $SummBonus, 'discount'=>$discountOnCheck);
		}

		$device->StringForPrinting = '';
		$device->DiscountOnCheck = floatval($discountOnCheck);

		if ( ($SummBonus > 0) && (floatval($checkamount) > 0) && (floatval($discountOnCheck) == 0) ) {
			//Косяк. В драйвере нет возможности применить натуральную скидку на весь чек
			//Что делать - непонятно
			//$device->DiscountOnCheck = round(100 * floatval($SummBonus) / floatval($checkamount), 2);
			//
			//Объект.Summ1             = СписокТоваров.Скидка;
			//Объект.StringForPrinting = "";
			//Объект.Discount();
		}

        if (floatval($SummMiscDiscount) > 0) {
            $this->_do_discount(array('amount' => $SummMiscDiscount, 'description' => ' '));
        }
        $device->CheckSubTotal();
		$subTotal = -1;
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) {
			$this->log(__METHOD__ . "   Ошибка приполучении ПодИтога чека. {$this->_internalGetLastError($device)} {$this->_internalGetLastErrorMessage($device)}\n", 2);
		} else {
			$subTotal = floatval(str_replace(',', '.', $device->Summ1));
		}

        if (floatval($SummBonus) > 0) {
            $this->_do_discount(array('amount' => $SummBonus, 'description' => ' '));
        }
        $device->Summ1 = floatval($Summ1);
		$device->Summ2 = floatval($Summ2);
		$device->Summ3 = floatval($Summ3);
		$device->Summ4 = floatval($Summ4);
//                $device->DiscountOnCheck = floatval($roundAmount);

		$device->CloseCheck();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_change = floatval($device->Change);
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			switch($device->CheckType){
				case 0:
					$checkRegister = self::REG_OPER_SALE_COUNTS;
					break;
				case 1:
					$checkRegister = self::REG_OPER_BUY_COUNTS;
					break;
				case 2:
					$checkRegister = self::REG_OPER_SALERET_COUNTS;
					break;
				case 3:
					$checkRegister = self::REG_OPER_BUYRET_COUNTS;
					break;
				default:
					$checkRegister = self::REG_OPER_SALE_COUNTS;
					break;
			}
			$this->_lastCheckNumber = $this->_getOperationReg($checkRegister);
			$this->_lastGlobalCheckNumber = $this->_getOperationReg(152);
			$this->_lastCheckAmount = $subTotal;
			$this->_sessionNumber = floatval($device->SessionNumber) + 1;

			return array('success'=>true);
		} else {
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}
	}

	/**
 * Проводит операцию продажа, печатает ее на чеке
 *
 * @param array $params Массив параметров
 * @return bool
 */
	protected function _do_sale($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();

		$quantity  = $params['quantity'];
		$itemCodes = explode(',', $params['itemCodes']);

		if (isset($params['mdlpReceiptLineAttr'])) {
            $mdlpReceiptLineAttr = iconv('UTF-8', 'CP866', $params['mdlpReceiptLineAttr']);
        }

		for ($itemIdx = 0; $itemIdx < $quantity; ++$itemIdx) {
			$itemCode = isset($itemCodes[$itemIdx]) ? $itemCodes[$itemIdx] : '';

			if ($itemCode !== '') {
				$device->FNOperation();
				$device->TagNumber = 1162;
				$device->TagType = 9;
				$device->TagValueBinHex = $itemCode;
				$device->FNSendTagOperation();
			}

			if (isset($mdlpReceiptLineAttr)) {
				$device->TagNumber = 1191;
				$device->TagType = 7;
				$device->TagValueStr = $mdlpReceiptLineAttr;
				$device->FNSendTagOperation();
			}
		}

        if (isset($params['priceWithFinalDiscount'])) {
            $price = $params['priceWithFinalDiscount'];
        } else {
            $price = $params['price'];
        }

		$item = $params['item'];

		$useJournalRibbon = false;
		if(isset($params['useJournalRibbon']))
			$useJournalRibbon = $params['useJournalRibbon'] === true;

		$department = isset($params['department']) ? $params['department'] : FP_DEFAULT_DEPARTMENT;

		/*	Sale работает в режимах 2 (проверка на окончание 24 часов производится запросом из ФП до
			выполнения операции), 4, 7, 8 (если статус8-го режима ККМ=0) и 9 (см. свойства ECRMode и
			ECRMode8Status).
		*/
		if (!$this->_waitMode(array(FR_ECRMode_SESSION_IS_OPEN, FR_ECRMode_SESSION_IS_CLOSED, FR_ECRMode_DEC_POINT_CHANGE_ALLOWED, FR_ECRMode_OPENED_DOCUMENT, FR_ECRMode_TECH_NULL_MODE), 4000)) {
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->log(__METHOD__ . " ----- end. ERROR. _waitMode. Текущий режим [ECRMode={$device->ECRMode}] не позволяет зарегистрировать продажу [$item]\n", 1);
			return array('success'=>false, 'error'=>"Текущий режим [ECRMode={$device->ECRMode}] не позволяет зарегистрировать продажу");
		}
		if (($device->ECRMode == FR_ECRMode_OPENED_DOCUMENT) && ($device->ECRMode8Status != 0)) {
			$this->log(__METHOD__ . " ----- end. ERROR . Открыт документ с типом отличным от ПРОДАЖА. Регистрация продажи невозможна \n", 1);
			return array('success'=>false, 'error'=>"Открыт документ с типом отличным от ПРОДАЖА. Регистрация продажи невозможна");
		}

		$this->log(__METHOD__ . " - [$item] [$price] [$quantity]\n", 3);

		$device->UseJournalRibbon = $useJournalRibbon;
		$device->Quantity = $quantity;
		$device->Price = $price;
		$device->Department = $department;

		$device->StringForPrinting = substr(iconv('utf-8', 'windows-1251', $item), 0, $this->getStringSize());
		$device->Sale();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			$this->log(__METHOD__ . " - finish OK\n", 3);
			return array('success'=>true);
		} else {
			$this->log(__METHOD__ . " - ERROR Закончилась бумага\n", 3);
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}

	}

	/**
	 * Проводит операцию продажа, печатает ее на чеке
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_returnsale($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();

                if (isset($params['priceWithFinalDiscount'])) {
                    $price = $params['priceWithFinalDiscount'];
                } else {
                    $price = $params['price'];
                }
                $item = $params['item'];
		$quantity = $params['quantity'];

		$useJournalRibbon = false;
		if(isset($params['useJournalRibbon']))
			$useJournalRibbon = $params['useJournalRibbon'] === true;

		$department = isset($params['department']) ? $params['department'] : FP_DEFAULT_DEPARTMENT;

		/*	Работает в режимах 2 (проверка на окончание 24 часов производится запросом
			из ФП до выполнения операции), 4, 7, 8 (если статус 8-го режима ККМ=2) и 9
		*/
		if (!$this->_waitMode(array(FR_ECRMode_SESSION_IS_OPEN, FR_ECRMode_SESSION_IS_CLOSED, FR_ECRMode_DEC_POINT_CHANGE_ALLOWED, FR_ECRMode_OPENED_DOCUMENT, FR_ECRMode_TECH_NULL_MODE), 4000)) {
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->log(__METHOD__ . " ----- end. ERROR. _waitMode. Текущий режим [ECRMode={$device->ECRMode}] не позволяет вернуть продажу [$item]\n", 1);
			return array('success'=>false, 'error'=>"Текущий режим [ECRMode={$device->ECRMode}] не позволяет вернуть продажу");
		}
		if (($device->ECRMode == FR_ECRMode_OPENED_DOCUMENT) && ($device->ECRMode8Status != 2)) {
			$this->log(__METHOD__ . " ----- end. ERROR . Открыт документ с типом отличным от ВОЗВРАТ. Регистрация возврата невозможна \n", 1);
			return array('success'=>false, 'error'=>"Открыт документ с типом отличным от ВОЗВРАТ [открыт тип $device->ECRMode8Status]. Регистрация возврата невозможна");
		}

		$this->log(__METHOD__ . " - [$item] [$price] [$quantity]\n", 3);

		$device->UseJournalRibbon = $useJournalRibbon;
		$device->Quantity = $quantity;
		$device->Price = $price;
		$device->Department = $department;

		$device->StringForPrinting = iconv('utf-8', 'windows-1251', $item);
		$device->ReturnSale();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			$this->log(__METHOD__ . " - finish OK\n", 3);
			return array('success'=>true);
		} else {
			$this->log(__METHOD__ . " - ERROR Закончилась бумага\n", 3);
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}

	}

	/**
	 * Прогон чека на несколько строк вперед
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_feed($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();
		sleep(1);
		$device->StringQuantity = $params['linesQuantity'];
		$device->FeedDocument();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			return array('success'=>true);
		} else {
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}

	}

	/**
	 * Печатает в чеке скидку.
         *
         * Функция на самом деле не делает скидку после 54-ФЗ.
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_discount($params){
		$this->log(__METHOD__ . " - start\n", 3);
		$discountAmount = $params['amount'];
		$discountDescription = $params['description'];
		if (!is_numeric ($discountAmount)) {
			return array('success'=>false, 'error'=>"Ошибка в сумме скидки: [$discountAmount]", 'errcode' => EC_DEVICE_ERROR);
		}

		$device = $this->get_NativeDevice();

		$device->CheckSubTotal();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$subTotal = str_replace(',', '.', $device->Summ1);

		if (!is_numeric($subTotal)) {
			return array('success'=>false, 'error'=>"Ошибка в сумме чека: [$subTotal]", 'errcode' => EC_DEVICE_ERROR);
		}

//		if (floatval($discountAmount) > floatval($subTotal)) {
//			return array('success'=>false, 'error'=>"Размер скидки [$discountAmount] превышает сумму чека [$subTotal]", 'errcode' => EC_DISCOUNT_TOO_BIG);
//		}

		$device->Summ1 = floatval($discountAmount);
		$device->StringForPrinting = substr(iconv('utf-8', 'windows-1251', $discountDescription), 0, $this->getStringSize());
                if ($this->isLegacyMode) {
                    $device->Discount;
                }
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			return array('success'=>true);
		} else {
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER, 'hasStart' => true);
		}
	}

	/**
	 * Обрезка чека
	 *
	 * @param array $params Массив параметров. Необязательный параметр $params[timeout] - время в миллисекундах, сколько ждать принтер чеков
	 * @return bool
	 */
	protected function _do_cut($params){
		$this->log(__METHOD__ . " ----- start with params: [" . json_encode($params, JSON_UNESCAPED_UNICODE ). "]\n", 3);
		$device = $this->get_NativeDevice();

		$timeoutms = isset($params['timeout']) ? $params['timeout'] : 1000;
		$ECRExcludeModes = array(
			FR_ECRMode_OPENED_DOCUMENT,
			FR_ECRMode_TEST_PRINT,
			FR_ECRMode_FISCAL_REP_PRINTING,
			FR_ECRMode_EKLZ_PRINTING,
			FR_ECRMode_PODKLAD_DOC_PRINTING
		);
		$ECRExcludeAdvancedMode = array(FR_ECRAdvMode_PRINTING, FR_ECRAdvMode_REPORT_PRINTING);
		if ($this->_waitEscapeFromMode($ECRExcludeModes, $ECRExcludeAdvancedMode, $timeoutms)) {
			$device->CutCheck();
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

			$this->log(__METHOD__ . " ----- end. OK. \n", 3);
			return array('success'=>true);
		} else {
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			return array('success'=>false, 'error'=>'Таймаут при обрезке чека');
		}
	}

	/**
	 * Печать штрихкодв ean13
	 * @param array $params массив параметров
	 * @return bool
	 */
	protected function _do_printbarcode($params){
		$this->log(__METHOD__ . " ----- start\n", 3);

		if(isset($params['ean13']))
		{
			$ean13 = $params['ean13'];

			if(!is_string($ean13))
			{
				$this->log(__METHOD__ . " ----- end. FALSE. Неверный параметр ean13 = $ean13 \n", 1);
				return array('success' => true);
                        }
		}
		else
		{
			$this->log(__METHOD__ . " ----- end. FALSE. Параметр ean13 не передан \n", 1);
                        return array('success' => true);
                }

		$device = $this->get_NativeDevice();
		$device->BarCode = $ean13;

		$device->PrintBarCode();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		$this->log(__METHOD__ . " ----- end. OK. \n", 3);
		return array('success'=>true);
	}

	/**
	 * Печать изображения из загруженного имеджсета
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _do_drow($params){
		$this->log(__METHOD__ . " ----- start\n", 3);

		if(isset($params['linestart']))
		{
			$linestart = $params['linestart'];

			if(!is_int($linestart))
			{
				$this->log(__METHOD__ . " ----- end. FALSE. Неверный параметр linestart = $linestart \n", 1);
				return array('success'=>false, 'error' => "Неверный параметр linestart = $linestart", 'errcode' => EC_API_ERROR);
			}
		}
		else
		{
			$this->log(__METHOD__ . " ----- end. FALSE. Параметр ean13 не передан \n", 1);
			return array('success'=>false, 'error' => "Параметр ean13 не передан", 'errcode' => EC_API_ERROR);
		}

		if(isset($params['linend']))
		{
			$linend = $params['linend'];

			if(!is_int($linend))
			{
				$this->log(__METHOD__ . " ----- end. FALSE. Неверный параметр linend = $linend \n", 1);
				return array('success'=>false, 'error' => "Неверный параметр linend = $linend", 'errcode' => EC_API_ERROR);
			}
		}
		else
		{
			$this->log(__METHOD__ . " ----- end. FALSE. Параметр ean13 не передан \n", 1);
			return array('success'=>false, 'error' => "Параметр ean13 не передан", 'errcode' => EC_API_ERROR);
		}

		$device = $this->get_NativeDevice();
		$device->FirstLineNumber = $linestart;
		$device->LastLineNumber = $linend;
		$device->Draw();

		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		$this->log(__METHOD__ . " ----- end. OK. \n", 3);
		return array('success'=>true);
	}

	/**
	 * Открыть денежный ящик
	 * @param type $params
	 */
	protected function _do_openDrawer($params)
	{
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
		$device->OpenDrawer();
		$this->log(__METHOD__ . " ----- end. OK\n", 1);
		return array('success'=>true);
	}

	/**
	 * Возвращает TRUE если указанное действие является регистрирующей операцией в чеке
	 *
	 * @param string $action Имя действия
	 * @return bool
	 */
	protected function _isFiscalAction($action) {
		return parent::_isFiscalAction($action);
	}


	/**
	 * Функция ожидания выхода из определенных режимов
	 *
	 * @param array $ECRExcludeModes массив со списком режимов, из которых устройство должно выйти
	 * @param array $ECRExludeAdvModes массив со списком расширенных режимов, из которых устройство должно выйти
	 * @param int $timeoutms Максимальное время ожидания в миллисекундах
	 * @return bool возвращает true если устройство вышло из указанных режимов
	 */
	protected function _waitEscapeFromMode ($ECRExcludeModes, $ECRExludeAdvModes, $timeoutms = 1000) {
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();
		$SLEEP_TIME_MS = 500;
		$timer = 0;
		while ($timer <= $timeoutms) {
			$device->GetShortECRStatus();
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return false;
			if (!in_array($device->ECRMode, $ECRExcludeModes) && !in_array($device->ECRAdvancedMode, $ECRExludeAdvModes)) return true;

			usleep($SLEEP_TIME_MS * 1000);
			$timer += $SLEEP_TIME_MS;
		}
		$this->log(__METHOD__ . " ----- WARNING. Timeout occured. time = $timer, ECRMode={$device->ECRMode}, ECRAdvancedMode={$device->ECRAdvancedMode} \n", 2);
		return false;
	}

	/**
	 * Функция ожидания перехода в определенный режим
	 *
	 * @param array $ECRModes массив со списком режимов, в который устройство должно перейти
	 * @param int $timeoutms Максимальное время ожидания в миллисекундах
	 * @return bool возвращает true если устройство перешло в один из указанных режимов
	 */
	protected function _waitMode ($ECRModes, $timeoutms = 1000) {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		$SLEEP_TIME_MS = 500;
		$timer = 0;
		while ($timer <= $timeoutms) {
			$device->GetShortECRStatus();
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return false;
			if (in_array($device->ECRMode, $ECRModes) ) 	return true;
			usleep($SLEEP_TIME_MS * 1000);
			$timer += $SLEEP_TIME_MS;
		}
		$this->log(__METHOD__ . " ----- WARNING. Timeout occured. time = $timer, ECRMode={$device->ECRMode}, ECRAdvancedMode={$device->ECRAdvancedMode} \n", 2);
		return false;
	}

	/**
	 * Функция ожидания завершения печати
	 *
	 * @param int $timeoutms Максимальное время ожидания в миллисекундах
	 * @return bool возвращает true если устройство вышло из указанных режимов
	 */
	protected function _waitWhilePrinting ($timeoutms = 3000) {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		$SLEEP_TIME_MS = 500;
		$timer = 0;
		while ($timer <= $timeoutms) {
			$device->GetShortECRStatus();
			if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) {
				return false;
			}
			if (!in_array($device->ECRAdvancedMode, array(FR_ECRAdvMode_PRINTING,FR_ECRAdvMode_PRINTING, FR_ECRAdvMode_REPORT_PRINTING))) {
				$this->log(__METHOD__ . " ----- ОК. Wait time: $timer \n", 3);
				return true;
			}
			usleep($SLEEP_TIME_MS * 1000);
			$timer += $SLEEP_TIME_MS;
		}
		$this->log(__METHOD__ . " ----- WARNING. Timeout occured. time = $timer \n", 2);
		return false;
	}


	/**
	 * Возвращает true если есть бумага
	 *
	 * @param array $params Массив параметров
	 * @return bool
	 */
	protected function _checkPaper(){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();
		$this->log(__METHOD__ . " Update ShortECRStatus \n", 3);
		$device->GetShortECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return true;
		$this->log(__METHOD__ . " ShortECRStatus updated\n", 3);
		return !in_array($device->ECRAdvancedMode, array(FR_ECRAdvMode_NOPAPER, FR_ECRAdvMode_NOPAPER_BLOCK));
	}


	/***************************************
	** PUBLIC METHODS
	*****************************************/


	/**
	 * Возвращает номер последнего навечатанного чека в рамках одной смены
	 *
	 * @param
	 * @return int
	 */
	public function GetLastCheckNumber() {
		return $this->_getOperationReg(148);
	}

	/**
	 * Возвращает общую информацию о ФР
	 *
	 * @param
	 * @return номер чека
	 */
	public function GetInfo($params) {
                $this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$device->GetECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		if($device->ECRMode == 4 && isset($params['dateTime'])) {
			$this->log(__METHOD__ . " ----- is ecr mode = 4. Set time from server \n", 3);
			$device->Time = date('H:i:s', strtotime($params['dateTime']));
			$device->SetTime();
			if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
		}

		$this->log(__METHOD__ . " ----- generate data\n", 3);

		$INN = $device->INN;
		$LastGlobalDocNumber = $device->OpenDocumentNumber;
		$EKLZExist = $device->EKLZIsPresent;
		$ECRMode = $device->ECRMode;
		$ECRModeDesc = iconv('windows-1251', 'utf-8', $device->ECRModeDescription);
		$ECRMode8Status = $device->ECRMode8Status;
		$ECRModeStatus = $device->ECRModeStatus;
		$ECRAdvancedMode = $device->ECRAdvancedMode;
		$ECRAdvancedModeDesc = iconv('windows-1251', 'utf-8', $device->ECRAdvancedModeDescription);
		$SerialNumber = $device->SerialNumber;
		$LastSessionNumber = $device->SessionNumber;
		$Date = $device->Date;
		$Time = $device->Time;

		$device->RegisterNumber = 148;
		$device->GetOperationReg();
		$LastCheckNumber = $device->ContentsOfOperationRegister;

		$result = array ('success' => true,
			'INN' => $INN,
			'LastGlobalDocNumber' => $LastGlobalDocNumber,
			'LastCheckNumber' => $LastCheckNumber,
			'EKLZExist' => $EKLZExist,
			'ECRMode' => $ECRMode,
			'ECRModeDesc' => $ECRModeDesc,
			'ECRMode8Status' => $ECRMode8Status,
			'ECRModeStatus' => $ECRModeStatus,
			'ECRAdvancedMode' => $ECRAdvancedMode,
			'ECRAdvancedModeDesc' => $ECRAdvancedModeDesc,
			'SerialNumber' => $SerialNumber,
			'LastSessionNumber' => $LastSessionNumber,
			'Date' => date('d.m.Y', time($Date)),
			'Time' => time($Time),
		);

		$this->log(__METHOD__ . " ----- end. OK. " . json_encode($result, JSON_UNESCAPED_UNICODE) . " \n", 3);
		return $result;
	}

	/**
	 * Получение всей информации по GetECRStatus
	 * @return type
	 */
	public function GetAllECRStatus()
	{
		$this->log(__METHOD__ . " ----- start\n", 3);

		// получить устройство
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		// получить статус устройства
		$device->GetECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$result = array(
			'success' => true,
			'data' => array(
				// док-я стр1
				'OperatorNumber' => $device->OperatorNumber,
				'ECRSoftVersion' => self::convEncode($device->ECRSoftVersion),
				'ECRBuild' => $device->ECRBuild,
				'ECRSoftDate' => self::convDate($device->ECRSoftDate),
				'LogicalNumber' => $device->LogicalNumber,
				'OpenDocumentNumber' => $device->OpenDocumentNumber,
				'ECRFlags' => $device->ECRFlags,
				'ReceiptRibbonIsPresent' => $device->ReceiptRibbonIsPresent,
				'JournalRibbonIsPresent' => $device->JournalRibbonIsPresent,
				'SlipDocumentIsPresent' => $device->SlipDocumentIsPresent,
				'SlipDocumentIsMoving' => $device->SlipDocumentIsMoving,
				'PointPosition' => $device->PointPosition,
				'EKLZIsPresent' => $device->EKLZIsPresent,
				'JournalRibbonOpticalSensor' => $device->JournalRibbonOpticalSensor,
				'ReceiptRibbonOpticalSensor' => $device->ReceiptRibbonOpticalSensor,
				// док-я стр2
				'JournalRibbonLever' => $device->JournalRibbonLever,
				'ReceiptRibbonLever' => $device->ReceiptRibbonLever,
				'LidPositionSensor' => $device->LidPositionSensor,
				'IsPrinterLeftSensorFailure' => $device->IsPrinterLeftSensorFailure,
				'IsPrinterRightSensorFailure' => $device->IsPrinterRightSensorFailure,
				'IsDrawerOpen' => $device->IsDrawerOpen,
				'IsEKLZOverflow' => $device->IsEKLZOverflow,
				'QuantityPointPosition' => $device->QuantityPointPosition,
				'ECRMode' => $device->ECRMode,
				'ECRModeDescription' => self::convEncode($device->ECRModeDescription),
				'ECRMode8Status' => $device->ECRMode8Status,
				'ECRModeStatus' => $device->ECRModeStatus,
				'ECRAdvancedMode' => $device->ECRAdvancedMode,
				'ECRAdvancedModeDescription' => self::convEncode($device->ECRAdvancedModeDescription),
				'PortNumber' => $device->PortNumber,
				'FMSoftVersion' => self::convEncode($device->FMSoftVersion),
				'FMBuild' => $device->FMBuild,
				'Date' => self::convDate($device->Date),
				'Time' => self::convTime($device->Time),
				'TimeStr' => self::convEncode($device->TimeStr),
				'FMFlags' => $device->FMFlags,
				// док-я стр3
				'FM1IsPresent' => $device->FM1IsPresent,
				'FM2IsPresent' => $device->FM2IsPresent,
				'LicenseIsPresent' => $device->LicenseIsPresent,
				'FMOverflow' => $device->FMOverflow,
				'IsBatteryLow' => $device->IsBatteryLow,
				'IsLastFMRecordCorrupted' => $device->IsLastFMRecordCorrupted,
				'IsFMSessionOpen' => true,// на некоторых моделях всегда false, поэтому флаг установлен принудительно
				'IsFM24HoursOver' => $device->IsFM24HoursOver,
				'SerialNumber' => self::convEncode($device->SerialNumber),
				'SessionNumber' => $device->SessionNumber,
				'FreeRecordInFM' => $device->FreeRecordInFM,
				'RegistrationNumber' => $device->RegistrationNumber,
				'FreeRegistration' => $device->FreeRegistration,
				'INN' => self::convEncode($device->INN),
			)
		);

		$this->log(__METHOD__ . " ----- end. OK. " . json_encode($result, JSON_UNESCAPED_UNICODE) . " \n", 3);

		// получить и вернуть все поля
		return $result;
	}

	/**
	 * Метод запрашивающий определенные регистры Штрих-М
	 * @param array $queryArray (name=>array(type,number))
	 * @return array (name=>result)
	 */
	private function _getRegisterCashArray($queryArray)
	{
		$result = array();

		foreach ($queryArray as $key => $value)
		{
			list($type, $number) = $value;

			if($type == self::REGTYPE_CASH)
			{
				$result[$key] = floatval($this->_getCashReg($number));
			}
			elseif($type == self::REGTYPE_OPERATION)
			{
				$result[$key] = floatval($this->_getOperationReg($number));
			}
			else
			{
				$result[$key] == null;
			}
		}

		return $result;
	}

        protected function isCheckPrintArrayConvertingRequired($isLegacy) {
            $this->isLegacyMode = $isLegacy;
            return false;
        }

        /**
	 * Получает информацию о смене
	 */
	public function GetShiftInfo()
	{
		// получить информацию по GetECRStatus
		$allECRStatus = $this->GetAllECRStatus();

		// получить информацию по портам
		if($allECRStatus['success'] !== true)
		{
			$allECRStatus['extinfo'] = 'В методе GetShiftInfo получение GetAllECRStatus прошло неудачно';
			return $allECRStatus;
		}

		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$device->GetECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$registers = $this->_getRegisterCashArray(array(
			// === ЧЕКОВ ПРОДАЖ ===
			'REG_OPER_SALE_COUNTS'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_SALE_COUNTS),
			'REG_OPER_SALE_COUNTS_DISCOUNT'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_SALE_COUNTS_DISCOUNT),
			'REG_CASH_SALE_SUM'		=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM),
			'REG_CASH_SALE_SUM_DISCOUNT'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM_DISCOUNT),
			'REG_CASH_SALE_SUM_CASH'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM_CASH),
			'REG_CASH_SALE_SUM_CREDIT'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM_CREDIT),
			'REG_CASH_SALE_SUM_TARE'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM_TARE),
			'REG_CASH_SALE_SUM_CARD'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALE_SUM_CARD),
			'REG_CASH_TOTAL_SALE_SUM'	=> array(self::REGTYPE_CASH, self::REG_CASH_TOTAL_SALE_SUM),
			// === Чеков покупок ===
			'REG_OPER_BUY_COUNTS'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_BUY_COUNTS),
			'REG_CASH_BUY_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_BUY_SUM),
			'REG_CASH_BUY_SUM_CASH'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUY_SUM_CASH),
			'REG_CASH_BUY_SUM_CREDIT'	=> array(self::REGTYPE_CASH, self::REG_CASH_BUY_SUM_CREDIT),
			'REG_CASH_BUY_SUM_TARE'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUY_SUM_TARE),
			'REG_CASH_BUY_SUM_CARD'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUY_SUM_CARD),
			// === Чеков возвратов продаж ===
			'REG_OPER_SALERET_COUNTS'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_SALERET_COUNTS),
			'REG_CASH_SALERET_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_SALERET_SUM),
			'REG_CASH_SALERET_SUM_CASH'		=> array(self::REGTYPE_CASH, self::REG_CASH_SALERET_SUM_CASH),
			'REG_CASH_SALERET_SUM_CREDIT'	=> array(self::REGTYPE_CASH, self::REG_CASH_SALERET_SUM_CREDIT),
			'REG_CASH_SALERET_SUM_TARE'		=> array(self::REGTYPE_CASH, self::REG_CASH_SALERET_SUM_TARE),
			'REG_CASH_SALERET_SUM_CARD'		=> array(self::REGTYPE_CASH, self::REG_CASH_SALERET_SUM_CARD),
			// === Чеков возвратов продаж ===
			'REG_OPER_BUYRET_COUNTS'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_BUYRET_COUNTS),
			'REG_CASH_BUYRET_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_BUYRET_SUM),
			'REG_CASH_BUYRET_SUM_CASH'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUYRET_SUM_CASH),
			'REG_CASH_BUYRET_SUM_CREDIT'	=> array(self::REGTYPE_CASH, self::REG_CASH_BUYRET_SUM_CREDIT),
			'REG_CASH_BUYRET_SUM_TARE'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUYRET_SUM_TARE),
			'REG_CASH_BUYRET_SUM_CARD'		=> array(self::REGTYPE_CASH, self::REG_CASH_BUYRET_SUM_CARD),
			// === Внесений ===
			'REG_OPER_MONEYINPUT_COUNT_GLOBAL'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_MONEYINPUT_COUNT_GLOBAL),
			'REG_OPER_MONEYINPUT_COUNT'			=> array(self::REGTYPE_OPERATION, self::REG_OPER_MONEYINPUT_COUNT),
			'REG_CASH_MONEYINPUT_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_MONEYINPUT_SUM),
			// === Выплат ===
			'REG_OPER_MONEYOUTPUT_COUNT_GLOBAL'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_MONEYOUTPUT_COUNT_GLOBAL),
			'REG_OPER_MONEYOUTPUT_COUNT'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_MONEYOUTPUT_COUNT),
			'REG_CASH_MONEYOUTPUT_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_MONEYOUTPUT_SUM),
			// === Аннулированных чеков ===
			'REG_OPER_ANNULATE_COUNT_GLOBAL'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_ANNULATE_COUNT_GLOBAL),
			// === Аннулированных чеков === :: за смену
			'REG_OPER_ANNULATE_SALE_COUNT'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_ANNULATE_SALE_COUNT),
			'REG_CASH_ANNULATE_SALE_SUM'		=> array(self::REGTYPE_CASH, self::REG_CASH_ANNULATE_SALE_SUM),
			'REG_OPER_ANNULATE_BUY_COUNT'		=> array(self::REGTYPE_OPERATION, self::REG_OPER_ANNULATE_BUY_COUNT),
			'REG_CASH_ANNULATE_BUY_SUM'			=> array(self::REGTYPE_CASH, self::REG_CASH_ANNULATE_BUY_SUM),
			'REG_OPER_ANNULATE_SALERET_COUNT'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_ANNULATE_SALERET_COUNT),
			'REG_CASH_ANNULATE_SALERET_SUM'		=> array(self::REGTYPE_CASH, self::REG_CASH_ANNULATE_SALERET_SUM),
			'REG_OPER_ANNULATE_BUYRET_COUNT'	=> array(self::REGTYPE_OPERATION, self::REG_OPER_ANNULATE_BUYRET_COUNT),
			'REG_CASH_ANNULATE_BUYRET_SUM'		=> array(self::REGTYPE_CASH, self::REG_CASH_ANNULATE_BUYRET_SUM),
			// ===Инкассация===
			'REG_CASH_ALLCASH_SUM'		=> array(self::REGTYPE_CASH, self::REG_CASH_ALLCASH_SUM),
			// === ВЫРУЧКА ===
			// Накопление продаж в 1 отдел в смене :: REG_CASH_SALE_SUM
		));

		// запрос по всем требующимся регистрам
		$result = array(
			'success' => true,
			'IsFMSessionOpen' => $allECRStatus['data']['IsFMSessionOpen'] || $allECRStatus['data']['IsFM24HoursOver'],
			'IsFM24HoursOver' => $allECRStatus['data']['IsFM24HoursOver'],
			'SessionNumber' => $allECRStatus['data']['SessionNumber'],
			'INN' => $allECRStatus['data']['INN'],
			'OpenDocumentNumber' => $allECRStatus['data']['OpenDocumentNumber'],
			'registers' => $registers,
			//'registerCash' => $registerCash,
			//'registerOperation' => $registerOperation,
		);

		$this->log(__METHOD__ . " ----- end. OK. " . json_encode($result, JSON_UNESCAPED_UNICODE) . " \n", 3);
		return $result;
	}

	/**
	 * Возобновляет печать чека после обрыва ленты
	 *
	 * @param
	 * @return
	 */
	public function ContinuePrint(){
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		if (   ($device->ECRAdvancedMode != FR_ECRAdvMode_WAIT_FOR_RESUME) &&
		     ( ($device->ECRAdvancedMode != FR_ECRAdvMode_OK) || ($device->ECRMode != FR_ECRMode_OPENED_DOCUMENT)) ) {
			$this->log(__METHOD__ . " ----- ERROR Невозможно продолжить печатать чек, т.к. подрежим не равен 3, а равен " . $device->ECRAdvancedMode . "\n", 1);
			return array(
				'success'=>false,
				'error'=>'Продолжение печати чека невозможно.',
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}

		$device->ContinuePrint();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

		if ($this->_checkPaper()){
			$this->log(__METHOD__ . " ----- end. OK. QuantityOfOperations = {$device->QuantityOfOperations}. \n", 3);
			return array('success' => true, 'quantityOfOperations' => $device->QuantityOfOperations);
		} else {
			$this->log(__METHOD__ . " ----- end. ERROR. Закончилась бумага \n", 1);
			return array('success'=>false, 'error'=>'Закончилась бумага', 'errcode' => EC_NO_PAPER);
		}
	}

	/**
	 * Печать штрих кода
	 */
	public function PrintBarCode($params)
	{
		return $this->_do_printbarcode($params);
	}

	/**
	 * Печать штрих кода
	 */
	public function Drow($params)
	{
		return $this->_do_drow($params);
	}

	/**
	 * Проверяет, готов ли принтер продолжить печатать чек после обрыва ленты
	 *
	 * @param
	 * @return bool true если принтер готов печатать дальше
	 */
	public function ReadyForContinuePrint(){
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		if (!$this->_checkPaper()){
			return array(
				'success'=>false,
				'error'=>'Для продолжения печати необходимо вставить новую ленту. Вставьте новую ленту и повторите операцию.',
				'errcode' => EC_NO_PAPER,
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}
		return array('success'=>true);
	}

	/**
	 * Возвращает success=true в том случае, если принтер готов напечатать новый чек
	 *
	 * @param
	 * @return
	 */
	public function ReadyForNewCheck($ignoreSession = false) {
		$this->log(__METHOD__ . " - start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		if (!$this->_checkPaper()){
			$this->log(__METHOD__ . " ----- end. Fail. Нет бумаги\n", 3);
			return array(
				'success'=>false,
				'error'=>'Закончилась бумага. Вставьте новую ленту и повторите операцию.',
				'errcode' => EC_NO_PAPER,
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}


		if ($device->ECRMode == FR_ECRMode_OPENED_DOCUMENT) {
			/*Есть открытый документ, который надо допечатать после того, как закончилась бумага */
			if ($device->ECRAdvancedMode == FR_ECRAdvMode_WAIT_FOR_RESUME) {
				return array(
					'success'=>false,
					'error'=>'Бумага вставлена, но есть незавершенный чек. Перед продолжением его необходимо либо отменить, либо завершить его печать.',
					'errcode' => EC_CONTINUE_OR_CANCEL_CHECK,
					'ecrmode'=>$device->ECRMode,
					'ecradvmode'=>$device->ECRAdvancedMode
				);
			}

			/*Есть открытый документ, хотя сбоев не было */
			return array(
				'success'=>false,
				'error'=>'Есть незавершенный чек. Перед продолжением его необходимо либо отменить, либо завершить его печать.',
				'errcode' => EC_CONTINUE_OR_CANCEL_CHECK,
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}

		//Продажа невозможна, т.к. смена закончилась. Надо закрыть смену
		if ($device->ECRMode == FR_ECRMode_24HOUR_BLOCK && $ignoreSession == false) {
			return array(
				'success'=>false,
				'error'=>'Текущая смена длится более 24 часов. Для продолжения работы выполните процедуру закрытия смены',
				'errcode' => EC_SESSION_24HOURS_BLOCK,
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}


		if (in_array($device->ECRMode, array(FR_ECRMode_SESSION_IS_OPEN, FR_ECRMode_SESSION_IS_CLOSED, FR_ECRMode_DEC_POINT_CHANGE_ALLOWED, FR_ECRMode_TECH_NULL_MODE, FR_ECRMode_24HOUR_BLOCK))) {

			if (in_array($device->ECRAdvancedMode, array(FR_ECRAdvMode_OK))) {
				return array('success' => true);
			} else {
				$desc = $device->ECRAdvancedModeDescription;
				$desc = iconv('windows-1251', 'utf-8', $desc);
				return array(
					'success' => false,
					'error' => 'Фискальный регистратор находится в подрежиме [' . $device->ECRAdvancedMode . ':' . $desc . '] и не может напечатать новый чек.',
					'ecrmode'=>$device->ECRMode,
					'ecradvmode'=>$device->ECRAdvancedMode
				);
			}
		} else {
			$desc = $device->ECRModeDescription;
			$desc = iconv('windows-1251', 'utf-8', $desc);
			return array(
				'success' => false,
				'error' => 'Фискальный регистратор находится в режиме [' . $device->ECRMode . ':' . $desc . '] и не может напечатать новый чек.',
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}

	}

	/**
	 * Отменяет ранее начатый чек
	 *
	 * @param
	 * @return
	 */
	 public function CheckCancel() {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		if (!$this->_checkPaper()){
                        $device->ContinuePrint();
                        $this->_waitWhilePrinting();
                        $device->CancelCheck();
                        $this->_waitWhilePrinting();

                        $this->log(__METHOD__ . " ----- end. Fail. Нет бумаги\n", 1);
			return array(
				'success'=>false,
				'error'=>'Закончилась бумага. Вставьте новую ленту и повторите операцию.',
				'errcode' => EC_NO_PAPER,
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}
		if($device->ECRMode == FR_ECRMode_SESSION_IS_OPEN || $device->ECRMode == FR_ECRMode_SESSION_IS_CLOSED)
		{
			if ($device->ECRAdvancedMode == FR_ECRAdvMode_WAIT_FOR_RESUME) {
				$this->log(__METHOD__ . " Определен режим зависшего отчета (с гашением или без). Производится попытка отмены (по факту допечатывания) документа.\n", 1);
			}

			// попытаемся оменить
			$this->log(__METHOD__ . " Попытка отмены \n", 1);
			$device->CancelCheck();
			$errResult = $this->_isDeviceFailed(__METHOD__);

			if($errResult['success'] === false)	// если просто отменить не удалост
			{
				if($errResult['device_errnum'] == 88)
				{
					// допечатываем чек
					$this->log(__METHOD__ . " Ошибка device_errnum=88 Попытка допечатывания чека \n", 1);
					$device->ContinuePrint();
					$this->_waitWhilePrinting();

					// снова попытаемся отменить чек
					$this->log(__METHOD__ . " Повторная попытка отмены \n", 1);
					$device->CancelCheck();
					$this->_waitWhilePrinting();
				}
			}

			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->_do_feed(array('linesQuantity' => 3));
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->_do_cut(array());
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

			$lastCheck = $this->GetLastCheckNumber();
			$this->log(__METHOD__ . " ----- end. OK\n", 1);
			return array('success'=>true, 'checknum' => $lastCheck);
		}
		elseif ($device->ECRMode != FR_ECRMode_OPENED_DOCUMENT) {

			$this->log(__METHOD__ . " ----- end. Fail. Нет открытого документа для отмены\n", 1);
			return array(
				'success'=>false,
				'error'=>'Нет открытого документа для отмены.',
				'errcode' => 'NO_OPEN_DOCUMENT',
				'ecrmode'=>$device->ECRMode,
				'ecradvmode'=>$device->ECRAdvancedMode
			);
		}
		else
		{
			$this->log(__METHOD__ . " Определен стандартный режм отмены \n", 1);

			$this->log(__METHOD__ . " Попытка отмены \n", 1);
			$device->CancelCheck();
			$errResult = $this->_isDeviceFailed(__METHOD__);
			if($errResult['success'] === false)
			{
				if($errResult['device_errnum'] == 88)	// был открытый чек
				{
					// допечатываем чек
					$this->log(__METHOD__ . " Ошибка device_errnum=88 Попытка допечатывания чека \n", 1);
					$device->ContinuePrint();
					$this->_waitWhilePrinting();

					// снова попытаемся отменить чек
					$this->log(__METHOD__ . " Повторная попытка отмены \n", 1);
					$device->CancelCheck();
					$this->_waitWhilePrinting();
				}
			}

			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->_do_feed(array('linesQuantity' => 3));
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
			$this->_do_cut(array());
			if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

			$lastCheck = $this->GetLastCheckNumber();
			$this->log(__METHOD__ . " ----- end. OK\n", 1);
			return array('success'=>true, 'checknum' => $lastCheck);
		}
	}

	/**
	 * Возвращает версию драйвера
	 *
	 * @param
	 * @return
	 */
	public function GetVersion() {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		$device->GetECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$result = $device->ECRSoftVersion;
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;
		$this->log(__METHOD__ . " ----- end OK\n", 3);
		return array('success'=>true, 'version' => $result, 'time' => time());
	}

	/**
	* Устанавливает тип подключения к фискальному регистратору
	*   0 - COM-порт
	*/
	public function SetConnectionType($contype) {
		parent::SetConnectionType($contype);
	}

	/**
	* Возвращает nип подключения к устройству
	*   0 - COM-порт
	*/
	public function GetConnectionType() {
		return parent::GetConnectionType();
	}


	/**
	* Устанавливает номер ком-порта, на котором сидит устройство
	*/
	public function SetComPort($comnumber) {
		parent::SetComPort($comnumber);
	}

	/**
	* Возвращает номер ком-порта, на котором сидит устройство
	*/
	public function GetComPort () {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$comNumber = parent::GetComPort();
		$autoOpen = $this->AutoOpen;
		$this->AutoOpen = false;
		try {
			$device = $this->get_NativeDevice();
			$comNumber = $device->ComNumber;
		} catch (Exception $e) {
			$this->AutoOpen = $autoOpen;
			throw $e;
		}
		$this->AutoOpen = $autoOpen;
		return array('success' => true, 'comnumber' => $comNumber);
	}

	/**
	 * Метод переводит ФР в режим «Открытой смены»
	 *
	 * @param
	 * @return
	 */
	 public function OpenSession() {
		$this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$device->OpenSession();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$value = floatval($device->SessionNumber);
		$this->log(__METHOD__ . " ----- end. OK. SessionNumber = {$value}+1\n", 3);
		return array('success'=>true, 'session' => $value+1);
	}

	/**
	 * Возвращает номер последней закрытой смены
	 *
	 * @param
	 * @return номер чека
	 */
	public function GetLastSessionNumber() {
		$sessionNumber = $this->_internalGetLastSessionNumber();
		return array('success' => isset($sessionNumber), 'session' => (isset($sessionNumber) ? $sessionNumber : 0) );
	}


	/**
	 * Метод печатает сменный отчет
	 *
	 * @params['withcleaning'] bool - если true, то отчет с гашением
	 * @return
	 */
	public function PrintReport($params) {
		$this->log(__METHOD__ . " ----- start\n", 3);
		if (!isset($params['withcleaning'])) {
			$this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр [withcleaning]\n", 1);
			return array('success'=>false, 'error'=> 'Не передан обязательный параметр [withcleaning]');
		}
		$clean = ($params['withcleaning'] != 0);

		$device = $this->get_NativeDevice();

		$device->GetShortECRStatus();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
		$ecrMode = $device->ECRMode;
		if ($clean && ($ecrMode == FR_ECRMode_SESSION_IS_CLOSED) ) {
			$this->log(__METHOD__ . " ----- end. Fail. Отчет с гашением не может быть напечатан, т.к. нет открытой смены\n", 1);
			return array('success'=>false, 'error'=> 'Отчет с гашением не может быть напечатан, т.к. нет открытой смены', 'errcode' => EC_NO_OPEN_SESSION);
		}

		$totalSalesCheckCount = floatval($this->_getOperationReg(self::REG_OPER_SALE_COUNTS));
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		// проверка того может ли принтер напечатать очередной чек (игнорируем блок 24 часа)
		$result = $this->ReadyForNewCheck(true);
		if (!$result['success']) {
			$this->log(__METHOD__ . " ----- end. Result = fail. Принтер не готов к печати нового чека. result=" . json_encode($result, JSON_UNESCAPED_UNICODE). "\n", 1);
			return $result;
		}

		if ($clean) {
            $this->setOperatorName($params['operatorName']);
            $this->log(__METHOD__ . " Запуск снятия отчета с гашением", 3);
			$device->PrintReportWithCleaning();
		} else {
			$this->log(__METHOD__ . " Запуск снятия отчета без гашения", 3);
			$device->PrintReportWithoutCleaning();
		}
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$this->_waitWhilePrinting();
		if ($errResult = $this->_isDeviceFailed(__METHOD__)) return $errResult;

// 		$this->_do_feed(array('linesQuantity' => '4'));
// 		$this->_do_cut(array(
// 			'timeout' => 10000
// 		));

		$totalSalesAmount = floatval($this->_getCashReg(self::REG_CASH_SALE_SUM));
		$session = floatval($device->SessionNumber);
		$session += 1;
		$serial = $this->_internalGetSerialNumber();
		$docNumber = $device->OpenDocumentNumber;
		$datetime = $this->_internalGetDateTime();

		if ($clean) {
			//$this->log(__METHOD__ . " Запуск снятия отчета с гашением", 3);
			return array('success'=>true, 'globalchecknum' => $docNumber, 'salesamount' => $totalSalesAmount, 'saleschecks' => $totalSalesCheckCount, 'session' => $session, 'serial' => $serial, 'datetime' => $datetime);
		} else {
			//$this->log(__METHOD__ . " Запуск снятия отчета без гашения", 3);
			$xreportNumber = floatval($this->_getOperationReg(self::REG_OPER_XREPORT_NUMBER));
			return array('success'=>true, 'globalchecknum' => $docNumber, 'xreportNumber' => $xreportNumber, 'salesamount' => $totalSalesAmount, 'saleschecks' => $totalSalesCheckCount, 'session' => $session, 'serial' => $serial, 'datetime' => $datetime);
		}
	}



	/**
	 * Метод регистрирует внесение денежной суммы в кассу.
	 *
	 * @param['amount'] - сумма внесения в рублях
	 * @return
	 */
	 public function CashIncome($params) {
		$this->log(__METHOD__ . " ----- start\n", 3);

		if ( !isset($params['amount']) || !is_numeric($params['amount']) ) {
			$this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр amount.\n", 1);
			return array('success'=>false, 'error' => 'Не передан обязательный параметр amount', 'errcode' => EC_API_ERROR);
		}
		$amount = floatval($params['amount']);

		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$device->Summ1 = $amount;
		$device->CashIncome();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		// режем
		$this->_do_feed(array('linesQuantity' => '4'));
		$this->_do_cut(array(
			'timeout' => 1000
		));

		$docNumber = $device->OpenDocumentNumber;
		$incomeNumber = floatval($this->_getOperationReg(self::REG_OPER_MONEYINPUT_COUNT));
		$incomeNumberGlobal = floatval($this->_getOperationReg(self::REG_OPER_MONEYINPUT_COUNT_GLOBAL));
		$serial = $this->_internalGetSerialNumber();
		$session = $this->_internalGetLastSessionNumber() + 1;
		$datetime = $this->_internalGetDateTime();
		$this->log(__METHOD__ . " ----- end. OK. Amount: {$amount}, DocNumber: {$docNumber}\n", 3);
		return array('success'=>true, 'amount' => $amount, 'globalchecknum' => $docNumber, 'incomeNumber' => $incomeNumber, 'incomeNumberGlobal' => $incomeNumberGlobal, 'serial' => $serial, 'session' => $session, 'datetime' => $datetime);
	}

	/**
	 * Метод регистрирует выплату из кассы денежной суммы
	 *
	 * @param['amount'] - сумма выплаты в рублях
	 * @return
	 */
	 public function CashOutcome($params) {
		$this->log(__METHOD__ . " ----- start\n", 3);

		if ( !isset($params['amount']) || !is_numeric($params['amount']) ) {
			$this->log(__METHOD__ . " ----- end. Fail. Не передан обязательный параметр amount.\n", 1);
			return array('success'=>false, 'error' => 'Не передан обязательный параметр amount', 'errcode' => EC_API_ERROR);
		}
		$amount = floatval($params['amount']);

		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		$device->Summ1 = $amount;
		$device->CashOutcome();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		// режем
		$this->_do_feed(array('linesQuantity' => '4'));
		$this->_do_cut(array(
			'timeout' => 1000
		));

		$docNumber = $device->OpenDocumentNumber;
		$outcomeNumber = floatval($this->_getOperationReg(self::REG_OPER_MONEYOUTPUT_COUNT));
		$outcomeNumberGlobal = floatval($this->_getOperationReg(self::REG_OPER_MONEYOUTPUT_COUNT_GLOBAL));
		$serial = $this->_internalGetSerialNumber();
		$session = $this->_internalGetLastSessionNumber() + 1;
		$datetime = $this->_internalGetDateTime();
		$this->log(__METHOD__ . " ----- end. OK. Amount: {$amount}, DocNumber: {$docNumber}\n", 3);
		return array('success'=>true, 'amount' => $amount, 'globalchecknum' => $docNumber, 'outcomeNumber' => $outcomeNumber, 'outcomeNumberGlobal' => $outcomeNumberGlobal, 'serial' => $serial, 'session' => $session, 'datetime' => $datetime);
	}



	/*******************************************************

	            Уникальные методы для ШТРИХ-ФР-К

	********************************************************/
	/**
	* Заставляет фискальный регистратор пищать
	*
	* @param
	* @return
	*/
	public function Beep() {
                $this->log(__METHOD__ . " ----- start\n", 3);
		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
		$device->Beep;
                $this->log(__METHOD__ . " ----- end. OK\n", 1);
		return array('success'=>true);
	}

	/**
	 * Получить данные из регистра фискального регистратора
	 * @param array $params - параметры вызова API
	 * @return array
	 */
	public function getRegister($params)
	{
		$this->log(__METHOD__ . " ----- start\n", 3);

		//@param integer $type		1 - денежный регистр, 2 - операционный регистр
		//@param integer $number	0..255 - номер регистра

		if(empty($params['type']))
		{
			return array(
				'success'=>false,
				'Не передан параметр тип регистра [type], требуется передать число 1(денежный) или 2(операционный)'
			);
		}
		$type = $params['type'];

		if(empty($params['number']))
		{
			return array(
				'success'=>false,
				'Не передан параметр номер регистра [number], требуется передать число 0..255'
			);
		}
		$number = $params['number'];

		if($type < 1 || $type > 2)
		{
			return array(
				'success'=>false,
				"Передан не правильный параметр тип регистра [type] = $type, требуется передать число 1(денежный) или 2(операционный)"
			);
		}

		if($number < 0 || $number > 255)
		{
			return array(
				'success'=>false,
				"Передан не правильный параметр номер регистра [number] = $number, требуется передать число 0..255"
			);
		}

		$device = $this->get_NativeDevice();

		// прлверяем что не было ошибок
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

		// Запрос всех данных которые только возможны по данному регистру
		if(isset($params['all']) && $params['all'] === true)
		{
			// указать какой регистр требуется получить
			$device->RegisterNumber = $number;

			if($type == self::REGTYPE_CASH)
			{
				$device->GetCashReg();
			}
			else if($type == self::REGTYPE_OPERATION)
			{
				$device->GetOperationReg();
			}
			else
			{
				return array(
					'success'=>false,
					"Передан не правильный параметр типа регистра [type] = $type, требуется передать число 1(денежный) или 2(операционный)"
				);
			}

			// прлверяем что не было ошибок
			if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
			$this->log(__METHOD__ . " ----- end. OK\n", 1);
			return array(
				'success'=>true,
				'OperatorNumber' => $device->OperatorNumber,
				'ContentsOfCashRegister' => floatval($device->ContentsOfCashRegister),
				'nameCashReg' => iconv('windows-1251', 'utf-8', $device->NameCashReg)
			);
		}
		else
		{
			if($type == self::REGTYPE_CASH)
			{
				$result = floatval($this->_getCashReg($number));
			}
			else if($type == self::REGTYPE_OPERATION)
			{
				$result = floatval($this->_getOperationReg($number));
			}
			else
			{
				return array(
					'success'=>false,
					"Передан не правильный параметр типа регистра [type] = $type, требуется передать число 1(денежный) или 2(операционный)"
				);
			}

			// прлверяем что не было ошибок
			if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;

			return array(
				'success'=>true,
				'ContentsOfCashRegister' => $result
			);
		}
	}

	public function InitConfig($params) {
		$this->log(__METHOD__ . " ----- start init config\n", 3);

		$device = $this->get_NativeDevice();
		if ($errResult = $this->_isDeviceFailed(__METHOD__, $device))
			return $errResult;

		$ecrsSrc = $this->GetAllECRStatus();
		if($ecrsSrc['data']['ECRMode'] == 4 && isset($params['dateTime'])) {
			$this->log(__METHOD__ . " ----- is ecr mode = 4. Set time from server \n", 3);
			$device->Time = date('H:i:s', strtotime($params['dateTime']));
			$device->SetTime();
			if ($errResult = $this->_isDeviceFailed(__METHOD__, $device)) return $errResult;
		}

		$this->log(__METHOD__ . " Disonnected OK\n", 3);

		return array('success' => true, 'info' => 'configure complete');
	}

        private function setOperatorName($name) {
            if (isset($name) && !empty($name)) {
                $device = $this->get_NativeDevice();
                $device->TableNumber = 2;
                $device->RowNumber = 30;
                $device->FieldNumber = 2;
                $device->ValueOfFieldString = iconv('utf-8', 'windows-1251', $name);
                $device->WriteTable();
            }
        }

}
